function [flow1, flow2, n, q, emission, emis_num_time, entering] = Link_S2nD( t, n, q, c, green_time, cycle, para, scenario )
%LINK_S2 Constant source link 
%   c is the available capacity of the downstream links (vector)
% beta=[0.5 0.5]; % the turning ratio of the current link to the downstream links
% mu = [1800, 1800]; % saturating flow rate
l_link = para(1); % link length
l_veh = para(2); % vehicle length
v_free = para(3)/3.6; % free flow speed, m/s
v_low = para(4)/3.6; % low speed, m/s
N_lane = para(5); % number of lanes of link
beta = para(6:7); % turning ratio for 1, 2
mu = para(8:9); % saturating flow rate for turning 1,2  
q_sum=sum(q); % the total queue length on the link
acc=2; %accelaration m/s2, speed up
dec=-2; %accelaration m/s2, slow down
C = floor(N_lane*l_link/l_veh); % the maximum capacity of the link
tao = floor(((C-q_sum)*l_veh)/(N_lane*v_free*cycle)); % delayed cycle
gama = rem(l_veh*(C-q_sum)/(N_lane*v_free), cycle); % delayed seconds
if tao<0
    gama=0; tao=0;
end
switch scenario
    case 0
        flow_2_enter = 0.*(t<=0)+200.*(t>=1 & t<=60)+200.*(t>=61 & t<=120)+200.*(t>=121 & t<=180)+500.*(t>=181 & t<=240)...
        +700.*(t>=241 & t<=300) + 1100.*(t>=301 & t<=360) + 1300.*(t>=361 & t<=420) + 1440.*(t>=421 & t<=480)+...
        1440.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 1000.*(t>=601 & t<=660) + 1440.*(t>=661 & t<=720)+...
        1300.*(t>=721 & t<=780) + 800.*(t>=781 & t<=840) + 800.*(t>=841 & t<=900) + 700.*(t>=901 & t<=960)+...
        1300.*(t>=961 & t<=1020) + 1440.*(t>=1021 & t<=1080) + 1440.*(t>=1081 & t<=1140) + 1300.*(t>=1141 & t<=1200)...
        +1100.*(t>=1201 & t<=1260) + 800.*(t>=1261 & t<=1320) + 400.*(t>=1321 & t<=1380) + 200.*(t>=1381 & t<=1440); % varying source flow
        t_=t-1;
        flow_2_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60)+200.*(t_>=61 & t_<=120)+200.*(t_>=121 & t_<=180)+500.*(t_>=181 & t_<=240)...
        +700.*(t_>=241 & t_<=300) + 1100.*(t_>=301 & t_<=360) + 1300.*(t_>=361 & t_<=420) + 1440.*(t_>=421 & t_<=480)+...
        1440.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 1000.*(t_>=601 & t_<=660) + 1440.*(t_>=661 & t_<=720)+...
        1300.*(t_>=721 & t_<=780) + 800.*(t_>=781 & t_<=840) + 800.*(t_>=841 & t_<=900) + 700.*(t_>=901 & t_<=960)+...
        1300.*(t_>=961 & t_<=1020) + 1440.*(t_>=1021 & t_<=1080) + 1440.*(t_>=1081 & t_<=1140) + 1300.*(t_>=1141 & t_<=1200)...
        +1100.*(t_>=1201 & t_<=1260) + 800.*(t_>=1261 & t_<=1320) + 400.*(t_>=1321 & t_<=1380) + 200.*(t_>=1381 & t_<=1440);
        t__=t_-1;
        flow_2_enter__ =  0.*(t__<=0)+200.*(t__>=1 & t__<=60)+200.*(t__>=61 & t__<=120)+200.*(t__>=121 & t__<=180)+500.*(t__>=181 & t__<=240)...
        +700.*(t__>=241 & t__<=300) + 1100.*(t__>=301 & t__<=360) + 1300.*(t__>=361 & t__<=420) + 1440.*(t__>=421 & t__<=480)+...
        1440.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 1000.*(t__>=601 & t__<=660) + 1440.*(t__>=661 & t__<=720)+...
        1300.*(t__>=721 & t__<=780) + 800.*(t__>=781 & t__<=840) + 800.*(t__>=841 & t__<=900) + 700.*(t__>=901 & t__<=960)+...
        1300.*(t__>=961 & t__<=1020) + 1440.*(t__>=1021 & t__<=1080) + 1440.*(t__>=1081 & t__<=1140) + 1300.*(t__>=1141 & t__<=1200)...
        +1100.*(t__>=1201 & t__<=1260) + 800.*(t__>=1261 & t__<=1320) + 400.*(t__>=1321 & t__<=1380) + 200.*(t__>=1381 & t__<=1440);
    case 1
        flow_2_enter = 1200.*(t<=360)+ 1200.*(t>=361 & t<=420) + 1200.*(t>=421 & t<=480)+...
        1200.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 1000.*(t>=601 & t<=660) + 800.*(t>=661 & t<=720)...
        + 0.*(t>=720); % varying source flow
        t_=t-1;
        flow_2_enter_ = 1200.*(t_<=360)+ 1200.*(t_>=361 & t_<=420) + 1200.*(t_>=421 & t_<=480)+...
        1200.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 1000.*(t_>=601 & t_<=660) + 800.*(t_>=661 & t_<=720)...
        + 0.*(t_>=720);
        t__=t_-1;
        flow_2_enter__ =  1200.*(t__<=360)+ 1200.*(t__>=361 & t__<=420) + 1200.*(t__>=421 & t__<=480)+...
        1200.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 1000.*(t__>=601 & t__<=660) + 800.*(t__>=661 & t__<=720)...
        + 0.*(t__>=720);
    case 2
        flow_2_enter = 0.*(t<=0)+200.*(t>=1 & t<=60)+200.*(t>=61 & t<=120)+200.*(t>=121 & t<=180)+500.*(t>=181 & t<=240)...
        +700.*(t>=241 & t<=300) + 1100.*(t>=301 & t<=360) + 1300.*(t>=361 & t<=420) + 1440.*(t>=421 & t<=480)+...
        1440.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 1000.*(t>=601 & t<=660) + 1440.*(t>=661 & t<=720)+...
        1300.*(t>=721 & t<=780) + 800.*(t>=781 & t<=840) + 800.*(t>=841 & t<=900) + 700.*(t>=901 & t<=960)+...
        1300.*(t>=961 & t<=1020) + 1440.*(t>=1021 & t<=1080) + 1440.*(t>=1081 & t<=1140) + 1300.*(t>=1141 & t<=1200)...
        +1100.*(t>=1201 & t<=1260) + 800.*(t>=1261 & t<=1320) + 400.*(t>=1321 & t<=1380) + 200.*(t>=1381 & t<=1440); % varying source flow
        t_=t-1;
        flow_2_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60)+200.*(t_>=61 & t_<=120)+200.*(t_>=121 & t_<=180)+500.*(t_>=181 & t_<=240)...
        +700.*(t_>=241 & t_<=300) + 1100.*(t_>=301 & t_<=360) + 1300.*(t_>=361 & t_<=420) + 1440.*(t_>=421 & t_<=480)+...
        1440.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 1000.*(t_>=601 & t_<=660) + 1440.*(t_>=661 & t_<=720)+...
        1300.*(t_>=721 & t_<=780) + 800.*(t_>=781 & t_<=840) + 800.*(t_>=841 & t_<=900) + 700.*(t_>=901 & t_<=960)+...
        1300.*(t_>=961 & t_<=1020) + 1440.*(t_>=1021 & t_<=1080) + 1440.*(t_>=1081 & t_<=1140) + 1300.*(t_>=1141 & t_<=1200)...
        +1100.*(t_>=1201 & t_<=1260) + 800.*(t_>=1261 & t_<=1320) + 400.*(t_>=1321 & t_<=1380) + 200.*(t_>=1381 & t_<=1440);
        t__=t_-1;
        flow_2_enter__ =  0.*(t__<=0)+200.*(t__>=1 & t__<=60)+200.*(t__>=61 & t__<=120)+200.*(t__>=121 & t__<=180)+500.*(t__>=181 & t__<=240)...
        +700.*(t__>=241 & t__<=300) + 1100.*(t__>=301 & t__<=360) + 1300.*(t__>=361 & t__<=420) + 1440.*(t__>=421 & t__<=480)+...
        1440.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 1000.*(t__>=601 & t__<=660) + 1440.*(t__>=661 & t__<=720)+...
        1300.*(t__>=721 & t__<=780) + 800.*(t__>=781 & t__<=840) + 800.*(t__>=841 & t__<=900) + 700.*(t__>=901 & t__<=960)+...
        1300.*(t__>=961 & t__<=1020) + 1440.*(t__>=1021 & t__<=1080) + 1440.*(t__>=1081 & t__<=1140) + 1300.*(t__>=1141 & t__<=1200)...
        +1100.*(t__>=1201 & t__<=1260) + 800.*(t__>=1261 & t__<=1320) + 400.*(t__>=1321 & t__<=1380) + 200.*(t__>=1381 & t__<=1440);
    case 3
        flow_2_enter = 0.*(t<=0)+200.*(t>=1 & t<=60)+200.*(t>=61 & t<=120)+200.*(t>=121 & t<=180)+500.*(t>=181 & t<=240)...
        +700.*(t>=241 & t<=300) + 1100.*(t>=301 & t<=360) + 1300.*(t>=361 & t<=420) + 1440.*(t>=421 & t<=480)+...
        1440.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 1000.*(t>=601 & t<=660) + 1440.*(t>=661 & t<=720)+...
        1300.*(t>=721 & t<=780) + 800.*(t>=781 & t<=840) + 800.*(t>=841 & t<=900) + 700.*(t>=901 & t<=960)+...
        1300.*(t>=961 & t<=1020) + 1440.*(t>=1021 & t<=1080) + 1440.*(t>=1081 & t<=1140) + 1300.*(t>=1141 & t<=1200)...
        +1100.*(t>=1201 & t<=1260) + 800.*(t>=1261 & t<=1320) + 400.*(t>=1321 & t<=1380) + 200.*(t>=1381 & t<=1440); % varying source flow
        t_=t-1;
        flow_2_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60)+200.*(t_>=61 & t_<=120)+200.*(t_>=121 & t_<=180)+500.*(t_>=181 & t_<=240)...
        +700.*(t_>=241 & t_<=300) + 1100.*(t_>=301 & t_<=360) + 1300.*(t_>=361 & t_<=420) + 1440.*(t_>=421 & t_<=480)+...
        1440.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 1000.*(t_>=601 & t_<=660) + 1440.*(t_>=661 & t_<=720)+...
        1300.*(t_>=721 & t_<=780) + 800.*(t_>=781 & t_<=840) + 800.*(t_>=841 & t_<=900) + 700.*(t_>=901 & t_<=960)+...
        1300.*(t_>=961 & t_<=1020) + 1440.*(t_>=1021 & t_<=1080) + 1440.*(t_>=1081 & t_<=1140) + 1300.*(t_>=1141 & t_<=1200)...
        +1100.*(t_>=1201 & t_<=1260) + 800.*(t_>=1261 & t_<=1320) + 400.*(t_>=1321 & t_<=1380) + 200.*(t_>=1381 & t_<=1440);
        t__=t_-1;
        flow_2_enter__ =  0.*(t__<=0)+200.*(t__>=1 & t__<=60)+200.*(t__>=61 & t__<=120)+200.*(t__>=121 & t__<=180)+500.*(t__>=181 & t__<=240)...
        +700.*(t__>=241 & t__<=300) + 1100.*(t__>=301 & t__<=360) + 1300.*(t__>=361 & t__<=420) + 1440.*(t__>=421 & t__<=480)+...
        1440.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 1000.*(t__>=601 & t__<=660) + 1440.*(t__>=661 & t__<=720)+...
        1300.*(t__>=721 & t__<=780) + 800.*(t__>=781 & t__<=840) + 800.*(t__>=841 & t__<=900) + 700.*(t__>=901 & t__<=960)+...
        1300.*(t__>=961 & t__<=1020) + 1440.*(t__>=1021 & t__<=1080) + 1440.*(t__>=1081 & t__<=1140) + 1300.*(t__>=1141 & t__<=1200)...
        +1100.*(t__>=1201 & t__<=1260) + 800.*(t__>=1261 & t__<=1320) + 400.*(t__>=1321 & t__<=1380) + 200.*(t__>=1381 & t__<=1440);
    case 4
        flow_2_enter = 0.*(t<=0)+200.*(t>=1 & t<=60)+200.*(t>=61 & t<=120)+200.*(t>=121 & t<=180)+500.*(t>=181 & t<=240)...
        +700.*(t>=241 & t<=300) + 1100.*(t>=301 & t<=360) + 1300.*(t>=361 & t<=420) + 1440.*(t>=421 & t<=480)+...
        1440.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 1000.*(t>=601 & t<=660) + 1440.*(t>=661 & t<=720)+...
        1300.*(t>=721 & t<=780) + 800.*(t>=781 & t<=840) + 800.*(t>=841 & t<=900) + 700.*(t>=901 & t<=960)+...
        1100.*(t>=961 & t<=1020) + 1140.*(t>=1021 & t<=1080) + 1140.*(t>=1081 & t<=1140) + 1100.*(t>=1141 & t<=1200)...
        +1100.*(t>=1201 & t<=1260) + 800.*(t>=1261 & t<=1320) + 400.*(t>=1321 & t<=1380) + 200.*(t>=1381 & t<=1440); % varying source flow
        t_=t-1;
        flow_2_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60)+200.*(t_>=61 & t_<=120)+200.*(t_>=121 & t_<=180)+500.*(t_>=181 & t_<=240)...
        +700.*(t_>=241 & t_<=300) + 1100.*(t_>=301 & t_<=360) + 1300.*(t_>=361 & t_<=420) + 1440.*(t_>=421 & t_<=480)+...
        1440.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 1000.*(t_>=601 & t_<=660) + 1440.*(t_>=661 & t_<=720)+...
        1300.*(t_>=721 & t_<=780) + 800.*(t_>=781 & t_<=840) + 800.*(t_>=841 & t_<=900) + 700.*(t_>=901 & t_<=960)+...
        1100.*(t_>=961 & t_<=1020) + 1140.*(t_>=1021 & t_<=1080) + 1140.*(t_>=1081 & t_<=1140) + 1100.*(t_>=1141 & t_<=1200)...
        +1100.*(t_>=1201 & t_<=1260) + 800.*(t_>=1261 & t_<=1320) + 400.*(t_>=1321 & t_<=1380) + 200.*(t_>=1381 & t_<=1440);
        t__=t_-1;
        flow_2_enter__ =  0.*(t__<=0)+200.*(t__>=1 & t__<=60)+200.*(t__>=61 & t__<=120)+200.*(t__>=121 & t__<=180)+500.*(t__>=181 & t__<=240)...
        +700.*(t__>=241 & t__<=300) + 1100.*(t__>=301 & t__<=360) + 1300.*(t__>=361 & t__<=420) + 1440.*(t__>=421 & t__<=480)+...
        1440.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 1000.*(t__>=601 & t__<=660) + 1440.*(t__>=661 & t__<=720)+...
        1300.*(t__>=721 & t__<=780) + 800.*(t__>=781 & t__<=840) + 800.*(t__>=841 & t__<=900) + 700.*(t__>=901 & t__<=960)+...
        1100.*(t__>=961 & t__<=1020) + 1140.*(t__>=1021 & t__<=1080) + 1140.*(t__>=1081 & t__<=1140) + 1100.*(t__>=1141 & t__<=1200)...
        +1100.*(t__>=1201 & t__<=1260) + 800.*(t__>=1261 & t__<=1320) + 400.*(t__>=1321 & t__<=1380) + 200.*(t__>=1381 & t__<=1440);
    case 5
        flow_2_enter = 0.*(t<=0)+200.*(t>=1 & t<=60)+200.*(t>=61 & t<=120)+200.*(t>=121 & t<=180)+500.*(t>=181 & t<=240)...
        +500.*(t>=241 & t<=300) + 700.*(t>=301 & t<=360) + 1340.*(t>=361 & t<=420) + 1440.*(t>=421 & t<=480)+...
        1340.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 1000.*(t>=601 & t<=660) + 940.*(t>=661 & t<=720)+...
        900.*(t>=721 & t<=780) + 800.*(t>=781 & t<=840) + 800.*(t>=841 & t<=900) + 1000.*(t>=901 & t<=960)+...
        1100.*(t>=961 & t<=1020) + 1240.*(t>=1021 & t<=1080) + 1240.*(t>=1081 & t<=1140) + 1200.*(t>=1141 & t<=1200)...
        +1100.*(t>=1201 & t<=1260) + 800.*(t>=1261 & t<=1320) + 400.*(t>=1321 & t<=1380) + 200.*(t>=1381 & t<=1440); % varying source flow
        t_=t-1;
        flow_2_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60)+200.*(t_>=61 & t_<=120)+200.*(t_>=121 & t_<=180)+500.*(t_>=181 & t_<=240)...
        +500.*(t_>=241 & t_<=300) + 700.*(t_>=301 & t_<=360) + 1340.*(t_>=361 & t_<=420) + 1440.*(t_>=421 & t_<=480)+...
        1340.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 1000.*(t_>=601 & t_<=660) + 940.*(t_>=661 & t_<=720)+...
        900.*(t_>=721 & t_<=780) + 800.*(t_>=781 & t_<=840) + 800.*(t_>=841 & t_<=900) + 1000.*(t_>=901 & t_<=960)+...
        1100.*(t_>=961 & t_<=1020) + 1240.*(t_>=1021 & t_<=1080) + 1240.*(t_>=1081 & t_<=1140) + 1200.*(t_>=1141 & t_<=1200)...
        +1100.*(t_>=1201 & t_<=1260) + 800.*(t_>=1261 & t_<=1320) + 400.*(t_>=1321 & t_<=1380) + 200.*(t_>=1381 & t_<=1440);
        t__=t_-1;
        flow_2_enter__ =  0.*(t__<=0)+200.*(t__>=1 & t__<=60)+200.*(t__>=61 & t__<=120)+200.*(t__>=121 & t__<=180)+500.*(t__>=181 & t__<=240)...
        +500.*(t__>=241 & t__<=300) + 700.*(t__>=301 & t__<=360) + 1340.*(t__>=361 & t__<=420) + 1440.*(t__>=421 & t__<=480)+...
        1340.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 1000.*(t__>=601 & t__<=660) + 940.*(t__>=661 & t__<=720)+...
        900.*(t__>=721 & t__<=780) + 800.*(t__>=781 & t__<=840) + 800.*(t__>=841 & t__<=900) + 1000.*(t__>=901 & t__<=960)+...
        1100.*(t__>=961 & t__<=1020) + 1240.*(t__>=1021 & t__<=1080) + 1240.*(t__>=1081 & t__<=1140) + 1200.*(t__>=1141 & t__<=1200)...
        +1100.*(t__>=1201 & t__<=1260) + 800.*(t__>=1261 & t__<=1320) + 400.*(t__>=1321 & t__<=1380) + 200.*(t__>=1381 & t__<=1440);
end
    enter=[flow_2_enter__ flow_2_enter_ flow_2_enter];
    entering=flow_2_enter;
flow_2_arriv = (cycle-gama)/cycle*enter(end-tao) + gama/cycle*enter(end-tao-1);
flow_arriv(1)=flow_2_arriv*beta(1);
flow_arriv(2)=flow_2_arriv*beta(2);

flow_leave(1)=min([(green_time/cycle)*mu(1), flow_arriv(1)+q(1)/cycle*3600, beta(1)*c(1)/cycle*3600]);
flow_leave(2)=min([(green_time/cycle)*mu(2), flow_arriv(2)+q(2)/cycle*3600, beta(2)*c(2)/cycle*3600]);
q(1)=q(1)+(flow_arriv(1)-flow_leave(1))*cycle/3600;
q(2)=q(2)+(flow_arriv(2)-flow_leave(2))*cycle/3600;
flow1 = flow_leave(1);
flow2 = flow_leave(2);
n_=n+(flow_2_enter-sum(flow_leave))*cycle/3600;
%% calculate the emission
% judge the current situation: saturated, over-saturated, unsaturated scenario
if q_sum <= sum(mu)*green_time/3600 && sum(mu)*green_time/3600<= flow_2_arriv*cycle/3600+q_sum
%     N_free = max(-1, n-cycle/3600*flow_2_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_2_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_2_arriv+q_sum-sum(mu)*green_time/3600;
    N_idl_2 = sum(mu)*green_time/3600-q_sum;
    N_idl_3 = 0;
    N_idl_4 = q_sum;
    N_dec = cycle/3600*flow_2_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = cycle - (v_low-v_free)/dec - (v_free-v_low)/acc;
    t_idl_3 = 0;
    t_idl_4 = cycle - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif sum(mu)*green_time/3600<q_sum
%     N_free = max(-1, n-cycle/3600*flow_2_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_2_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_2_arriv;
    N_idl_2 = 0;
    N_idl_3 = q_sum-sum(mu)*green_time/3600;
    N_idl_4 = sum(mu)*green_time/3600;
    N_dec = cycle/3600*flow_2_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = 0;
    t_idl_3 = cycle;
    t_idl_4 = cycle - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif flow_2_arriv*cycle/3600+q_sum<sum(mu)*green_time/3600
    Gs = (cycle/3600*flow_2_arriv+q_sum-green_time/3600*flow_2_arriv)/(sum(mu)-flow_2_arriv)*3600;
    Gd = (green_time/3600*sum(mu)-cycle/3600*flow_2_arriv-q_sum)/(sum(mu)-flow_2_arriv)*3600;
%     N_free = max(-1, n-cycle/3600*flow_2_arriv-q_sum);
    
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_2_arriv-q_sum;
    N_idl_1 = 0;
    N_idl_2 = Gs*sum(mu)/3600-q_sum;
    N_idl_3 = 0;
    N_idl_4 = q_sum;
    N_dec = (cycle-Gd)*flow_2_arriv/3600;
    N_acc =Gs*sum(mu)/3600;
    N_non = Gd*flow_2_arriv/3600;
    t_free = cycle;
    t_idl_1 = 0;
    t_idl_2 = max(0, cycle-Gd-(v_low-v_free)/dec-(v_free-v_low)/acc);
    t_idl_3 = 0;
    t_idl_4 = max(0, cycle - Gd - (v_free-v_low)/acc);
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = Gd;
else
    error('Something goes wrong with the situation judging');
end
if N_free<0
    warning('N_free is 0');
end
% calculate the emissions of all the vehicles
% [CO, HC, NOx, CO2, Fc] = VTmicro(v, a, 2);
e_free = 0.0032;

e_idl = 0.0016;

e_dec = 0.0023;

e_acc = 0.0118;

emission = (N_free*t_free+N_non*t_non).*e_free+(N_idl_1*t_idl_1+N_idl_2*t_idl_2+N_idl_3*t_idl_3+N_idl_4*t_idl_4)*e_idl...
    + N_dec*t_dec*e_dec + N_acc*t_acc*e_acc;
emis_num_time=[N_free N_idl_1+N_idl_2+N_idl_3+N_idl_4 N_dec N_acc t_free t_idl_1+t_idl_2+t_idl_3+t_idl_4 t_dec t_acc];
n=n_;
% flow_2 = 1150.*(t>=0 & t<425) + 2360.*(t>=425 & t<516) + 1545.*(t>=516 & t<702) + 2408.*(t>=702 & t<777)...
%     + 1358.*(t>=777 & t<1044) + 2687.*(t>=1044 & t<1140)+ 1040.*(t>=1140 & t<1440); % constant source flow
% if c(1)>=1 && c(2)>=1
%     flow(1)=flow_2*beta(1);
%     flow(2)=flow_2*beta(2);
% elseif c(1)>=1 && c(2)<1
%     flow(1)=flow_2*beta(1);
%     flow(2)=0;
% elseif c(1)<1 && c(2)>=1
%     flow(1)=0;
%     flow(2)=flow_2*beta(2);
% else
%     flow(1)=0;
%     flow(2)=0;
% end
% 
% flow(1)=(1-green_time/cycle)*flow(1);
% flow(2)=(1-green_time/cycle)*flow(2);
% flow1 = flow(1);
% flow2 = flow(2);
end

