function [flow, n, q, emission] = Link_S5nLD( t, n, q, c, green_time, cycle, para, scale, scenario )
%LINK_S5 Varying flow of source 5
%   c is the available capacity of the downstream links (vector)
% beta=1; % the turning ratio of the current link to the downstream links
% flow_5 = 3500/5.*(t>=1 & t<2)+4970/5.*(t>=2 & t<3)+8000/5.*(t>=3 & t<4)+11750/5.*(t>=4 & t<5)...
%         +14000/5.*(t>=5 & t<6)+12000/5.*(t>=6 & t<7)+7000/5.*(t>=7 & t<8) + 2500/5.*(t>=8); % varying source flow
% flow_5 = 10300/10.*(t>=1 & t<2)+22375/10.*(t>=2 & t<3)+25500/10.*(t>=3 & t<4)+9000/10.*(t>=4 & t<5)...
%         +5000/10.*(t>=5); % varying source flow
% t=t-1;
% flow_5 = 33000/60.*(t>=0 & t<4) + 49830/60.*(t>=4 & t<5) + 99150/60.*(t>=5 & t<6) + 114060/60.*(t>=6 & t<7)...
%     + 114600/60.*(t>=7 & t<8) + 94900/60.*(t>=8 & t<9) + 76800/60.*(t>=9 & t<10) + 64610/60.*(t>=10 & t<11)...
%     + 73476/60.*(t>=11 & t<12) + 118952/60.*(t>=12 & t<13) + 74709/60.*(t>=13 & t<14) + 67875/60.*(t>=14 & t<15)...
%     + 87300/60.*(t>=15 & t<16) + 84384/60.*(t>=16 & t<17) + 116904/60.*(t>=17 & t<18) + 119021/60.*(t>=18 & t<19)...
%     + 103500/60.*(t>=19 & t<20) + 94980/60.*(t>=20 & t<21) + 88954/60.*(t>=21 & t<22) + 46789/60.*(t>=22 & t<23)...
%     + 33495/60.*(t>=23 & t<24);
% flow_5 = flow_5*60;  
% if c>=1
%     flow=flow_5*beta;
% else
%     flow=0;
% end
% flow = (green_time/cycle)*flow;
l_link = para(1); % link length
l_veh = para(2); % vehicle length
v_free = para(3)/3.6; % free flow speed, m/s
v_low = para(4)/3.6; % low speed, m/s
N_lane = para(5); % number of lanes of link
beta = para(6:7); % turning ratio for 1, 2
mu = para(8:9); % saturating flow rate for turning 1,2  
C = floor(N_lane*l_link/l_veh)*scale; % the maximum capacity of the link
q_sum=sum(q);
acc=2; %accelaration m/s2, speed up
dec=-2; %accelaration m/s2, slow down
tao = floor(((C-q_sum)*l_veh/scale)/(N_lane*v_free*cycle)); % delayed cycle
gama = rem(l_veh*(C-q_sum)/scale/(N_lane*v_free), cycle); % delayed seconds
if tao<0
    gama=0; tao=0;
end
switch scenario
    case 0
        flow_5_enter = 0.*(t<=0)+200.*(t>=1 & t<=60/scale) + 200.*(t>=60/scale+1 & t<=2*60/scale) + 200.*(t>=2*60/scale+1 & t<=3*60/scale) + 500.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +700.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1100.*(t>=5*60/scale+1 & t<=6*60/scale)+1300.*(t>=6*60/scale+1 & t<=7*60/scale)+1440.*(t>=7*60/scale+1 & t<=8*60/scale)+1440.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+1000.*(t>=10*60/scale+1 & t<=11*60/scale)+1440.*(t>=11*60/scale+1 & t<=12*60/scale)+1300.*(t>=12*60/scale+1 & t<=13*60/scale)+800.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +800.*(t>=14*60/scale+1 & t<=15*60/scale)+700.*(t>=15*60/scale+1 & t<=16*60/scale)+1300.*(t>=16*60/scale+1 & t<=17*60/scale)+1440.*(t>=17*60/scale+1 & t<=18*60/scale)+1440.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +1300.*(t>=19*60/scale+1 & t<=20*60/scale) + 1100.*(t>=20*60/scale+1 & t<=21*60/scale) + 800.*(t>=21*60/scale+1 & t<=22*60/scale) + 400.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +200.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_5_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60/scale) + 200.*(t_>=60/scale+1 & t_<=2*60/scale) + 200.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 500.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +700.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1100.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1300.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1440.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1440.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+1000.*(t_>=10*60/scale+1 & t_<=11*60/scale)+1440.*(t_>=11*60/scale+1 & t_<=12*60/scale)+1300.*(t_>=12*60/scale+1 & t_<=13*60/scale)+800.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +800.*(t_>=14*60/scale+1 & t_<=15*60/scale)+700.*(t_>=15*60/scale+1 & t_<=16*60/scale)+1300.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1440.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1440.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +1300.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1100.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 800.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 400.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +200.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_5_enter__ = 0.*(t__<=0)+200.*(t__>=1 & t__<=60/scale) + 200.*(t__>=60/scale+1 & t__<=2*60/scale) + 200.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 500.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +700.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1100.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1300.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1440.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1440.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+1000.*(t__>=10*60/scale+1 & t__<=11*60/scale)+1440.*(t__>=11*60/scale+1 & t__<=12*60/scale)+1300.*(t__>=12*60/scale+1 & t__<=13*60/scale)+800.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +800.*(t__>=14*60/scale+1 & t__<=15*60/scale)+700.*(t__>=15*60/scale+1 & t__<=16*60/scale)+1300.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1440.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1440.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +1300.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1100.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 800.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 400.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +200.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 1
        flow_5_enter = 700.*(t<=6*60/scale)+700.*(t>=6*60/scale+1 & t<=7*60/scale)+900.*(t>=7*60/scale+1 & t<=8*60/scale)+1300.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1300.*(t>=9*60/scale+1 & t<=10*60/scale)+1200.*(t>=10*60/scale+1 & t<=11*60/scale)+1000.*(t>=11*60/scale+1 & t<=12*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_5_enter_ = 700.*(t_<=6*60/scale)+700.*(t_>=6*60/scale+1 & t_<=7*60/scale)+900.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1300.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1300.*(t_>=9*60/scale+1 & t_<=10*60/scale)+1200.*(t_>=10*60/scale+1 & t_<=11*60/scale)+1000.*(t_>=11*60/scale+1 & t_<=12*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_5_enter__ = 700.*(t__<=6*60/scale)+700.*(t__>=6*60/scale+1 & t__<=7*60/scale)+900.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1300.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1300.*(t__>=9*60/scale+1 & t__<=10*60/scale)+1200.*(t__>=10*60/scale+1 & t__<=11*60/scale)+1000.*(t__>=11*60/scale+1 & t__<=12*60/scale);
    case 2
        flow_5_enter = 0.*(t<=0)+200.*(t>=1 & t<=60/scale) + 200.*(t>=60/scale+1 & t<=2*60/scale) + 200.*(t>=2*60/scale+1 & t<=3*60/scale) + 500.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +700.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1100.*(t>=5*60/scale+1 & t<=6*60/scale)+1300.*(t>=6*60/scale+1 & t<=7*60/scale)+1440.*(t>=7*60/scale+1 & t<=8*60/scale)+1440.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+1000.*(t>=10*60/scale+1 & t<=11*60/scale)+1440.*(t>=11*60/scale+1 & t<=12*60/scale)+1300.*(t>=12*60/scale+1 & t<=13*60/scale)+800.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +800.*(t>=14*60/scale+1 & t<=15*60/scale)+700.*(t>=15*60/scale+1 & t<=16*60/scale)+1300.*(t>=16*60/scale+1 & t<=17*60/scale)+1440.*(t>=17*60/scale+1 & t<=18*60/scale)+1440.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +1300.*(t>=19*60/scale+1 & t<=20*60/scale) + 1100.*(t>=20*60/scale+1 & t<=21*60/scale) + 800.*(t>=21*60/scale+1 & t<=22*60/scale) + 400.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +200.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_5_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60/scale) + 200.*(t_>=60/scale+1 & t_<=2*60/scale) + 200.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 500.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +700.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1100.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1300.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1440.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1440.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+1000.*(t_>=10*60/scale+1 & t_<=11*60/scale)+1440.*(t_>=11*60/scale+1 & t_<=12*60/scale)+1300.*(t_>=12*60/scale+1 & t_<=13*60/scale)+800.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +800.*(t_>=14*60/scale+1 & t_<=15*60/scale)+700.*(t_>=15*60/scale+1 & t_<=16*60/scale)+1300.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1440.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1440.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +1300.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1100.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 800.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 400.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +200.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_5_enter__ = 0.*(t__<=0)+200.*(t__>=1 & t__<=60/scale) + 200.*(t__>=60/scale+1 & t__<=2*60/scale) + 200.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 500.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +700.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1100.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1300.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1440.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1440.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+1000.*(t__>=10*60/scale+1 & t__<=11*60/scale)+1440.*(t__>=11*60/scale+1 & t__<=12*60/scale)+1300.*(t__>=12*60/scale+1 & t__<=13*60/scale)+800.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +800.*(t__>=14*60/scale+1 & t__<=15*60/scale)+700.*(t__>=15*60/scale+1 & t__<=16*60/scale)+1300.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1440.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1440.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +1300.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1100.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 800.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 400.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +200.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 3
        flow_5_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60/scale) + 1440.*(t>=60/scale+1 & t<=2*60/scale) + 1350.*(t>=2*60/scale+1 & t<=3*60/scale) + 1350.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +1280.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1280.*(t>=5*60/scale+1 & t<=6*60/scale)+1100.*(t>=6*60/scale+1 & t<=7*60/scale)+1100.*(t>=7*60/scale+1 & t<=8*60/scale)+1000.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+900.*(t>=10*60/scale+1 & t<=11*60/scale)+800.*(t>=11*60/scale+1 & t<=12*60/scale)+700.*(t>=12*60/scale+1 & t<=13*60/scale)+700.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +600.*(t>=14*60/scale+1 & t<=15*60/scale)+600.*(t>=15*60/scale+1 & t<=16*60/scale)+900.*(t>=16*60/scale+1 & t<=17*60/scale)+1200.*(t>=17*60/scale+1 & t<=18*60/scale)+1300.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +800.*(t>=19*60/scale+1 & t<=20*60/scale) + 1000.*(t>=20*60/scale+1 & t<=21*60/scale) + 1200.*(t>=21*60/scale+1 & t<=22*60/scale) + 1300.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +1440.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_5_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60/scale) + 1440.*(t_>=60/scale+1 & t_<=2*60/scale) + 1350.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 1350.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +1280.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1280.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1100.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1100.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1000.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+900.*(t_>=10*60/scale+1 & t_<=11*60/scale)+800.*(t_>=11*60/scale+1 & t_<=12*60/scale)+700.*(t_>=12*60/scale+1 & t_<=13*60/scale)+700.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +600.*(t_>=14*60/scale+1 & t_<=15*60/scale)+600.*(t_>=15*60/scale+1 & t_<=16*60/scale)+900.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1200.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1300.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +800.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1000.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 1200.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 1300.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +1440.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_5_enter__ = 0.*(t__<=0)+1440.*(t__>=1 & t__<=60/scale) + 1440.*(t__>=60/scale+1 & t__<=2*60/scale) + 1350.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 1350.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +1280.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1280.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1100.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1100.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1000.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+900.*(t__>=10*60/scale+1 & t__<=11*60/scale)+800.*(t__>=11*60/scale+1 & t__<=12*60/scale)+700.*(t__>=12*60/scale+1 & t__<=13*60/scale)+700.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +600.*(t__>=14*60/scale+1 & t__<=15*60/scale)+600.*(t__>=15*60/scale+1 & t__<=16*60/scale)+900.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1200.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1300.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +800.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1000.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 1200.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 1300.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +1440.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 4
        flow_5_enter = 0.*(t<=0)+200.*(t>=1 & t<=60/scale) + 200.*(t>=60/scale+1 & t<=2*60/scale) + 200.*(t>=2*60/scale+1 & t<=3*60/scale) + 500.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +700.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1100.*(t>=5*60/scale+1 & t<=6*60/scale)+1300.*(t>=6*60/scale+1 & t<=7*60/scale)+1440.*(t>=7*60/scale+1 & t<=8*60/scale)+1440.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+1000.*(t>=10*60/scale+1 & t<=11*60/scale)+1440.*(t>=11*60/scale+1 & t<=12*60/scale)+1300.*(t>=12*60/scale+1 & t<=13*60/scale)+800.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +800.*(t>=14*60/scale+1 & t<=15*60/scale)+700.*(t>=15*60/scale+1 & t<=16*60/scale)+1100.*(t>=16*60/scale+1 & t<=17*60/scale)+1140.*(t>=17*60/scale+1 & t<=18*60/scale)+1140.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +1100.*(t>=19*60/scale+1 & t<=20*60/scale) + 1100.*(t>=20*60/scale+1 & t<=21*60/scale) + 800.*(t>=21*60/scale+1 & t<=22*60/scale) + 400.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +200.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_5_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60/scale) + 200.*(t_>=60/scale+1 & t_<=2*60/scale) + 200.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 500.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +700.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1100.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1300.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1440.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1440.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+1000.*(t_>=10*60/scale+1 & t_<=11*60/scale)+1440.*(t_>=11*60/scale+1 & t_<=12*60/scale)+1300.*(t_>=12*60/scale+1 & t_<=13*60/scale)+800.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +800.*(t_>=14*60/scale+1 & t_<=15*60/scale)+700.*(t_>=15*60/scale+1 & t_<=16*60/scale)+1100.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1140.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1140.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +1100.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1100.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 800.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 400.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +200.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_5_enter__ = 0.*(t__<=0)+200.*(t__>=1 & t__<=60/scale) + 200.*(t__>=60/scale+1 & t__<=2*60/scale) + 200.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 500.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +700.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1100.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1300.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1440.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1440.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+1000.*(t__>=10*60/scale+1 & t__<=11*60/scale)+1440.*(t__>=11*60/scale+1 & t__<=12*60/scale)+1300.*(t__>=12*60/scale+1 & t__<=13*60/scale)+800.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +800.*(t__>=14*60/scale+1 & t__<=15*60/scale)+700.*(t__>=15*60/scale+1 & t__<=16*60/scale)+1100.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1140.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1140.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +1100.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1100.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 800.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 400.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +200.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 5    
        flow_5_enter = 0.*(t<=0)+200.*(t>=1 & t<=60/scale) + 200.*(t>=60/scale+1 & t<=2*60/scale) + 200.*(t>=2*60/scale+1 & t<=3*60/scale) + 500.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +500.*(t>=4*60/scale+1 & t<=5*60/scale)+ 700.*(t>=5*60/scale+1 & t<=6*60/scale)+1340.*(t>=6*60/scale+1 & t<=7*60/scale)+1440.*(t>=7*60/scale+1 & t<=8*60/scale)+1340.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+1000.*(t>=10*60/scale+1 & t<=11*60/scale)+940.*(t>=11*60/scale+1 & t<=12*60/scale)+900.*(t>=12*60/scale+1 & t<=13*60/scale)+800.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +800.*(t>=14*60/scale+1 & t<=15*60/scale)+1000.*(t>=15*60/scale+1 & t<=16*60/scale)+1100.*(t>=16*60/scale+1 & t<=17*60/scale)+1240.*(t>=17*60/scale+1 & t<=18*60/scale)+1240.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +1200.*(t>=19*60/scale+1 & t<=20*60/scale) + 1100.*(t>=20*60/scale+1 & t<=21*60/scale) + 800.*(t>=21*60/scale+1 & t<=22*60/scale) + 400.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +200.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_5_enter_ = 0.*(t_<=0)+200.*(t_>=1 & t_<=60/scale) + 200.*(t_>=60/scale+1 & t_<=2*60/scale) + 200.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 500.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +500.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 700.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1340.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1440.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1340.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+1000.*(t_>=10*60/scale+1 & t_<=11*60/scale)+940.*(t_>=11*60/scale+1 & t_<=12*60/scale)+900.*(t_>=12*60/scale+1 & t_<=13*60/scale)+800.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +800.*(t_>=14*60/scale+1 & t_<=15*60/scale)+1000.*(t_>=15*60/scale+1 & t_<=16*60/scale)+1100.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1240.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1240.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +1200.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1100.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 800.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 400.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +200.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_5_enter__ = 0.*(t__<=0)+200.*(t__>=1 & t__<=60/scale) + 200.*(t__>=60/scale+1 & t__<=2*60/scale) + 200.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 500.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +500.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 700.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1340.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1440.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1340.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+1000.*(t__>=10*60/scale+1 & t__<=11*60/scale)+940.*(t__>=11*60/scale+1 & t__<=12*60/scale)+900.*(t__>=12*60/scale+1 & t__<=13*60/scale)+800.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +800.*(t__>=14*60/scale+1 & t__<=15*60/scale)+1000.*(t__>=15*60/scale+1 & t__<=16*60/scale)+1100.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1240.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1240.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +1200.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1100.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 800.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 400.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +200.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
end
enter=[flow_5_enter__ flow_5_enter_ flow_5_enter];
flow_5_arriv = (cycle-gama)/cycle*enter(end-tao) + gama/cycle*enter(end-tao-1); % arriving flow at current cycle
flow_arriv(1)=flow_5_arriv*beta(1);
flow_arriv(2)=flow_5_arriv*beta(2);

flow_leave(1)=min([(green_time/cycle)*mu(1), flow_arriv(1)+q(1)/cycle*3600, beta(1)*c/cycle*3600]);
flow_leave(2)=min([(green_time/cycle)*mu(2), flow_arriv(2)+q(2)/cycle*3600, beta(2)*c/cycle*3600]);
q(1)=q(1)+(flow_arriv(1)-flow_leave(1))*cycle/3600;
q(2)=q(2)+(flow_arriv(2)-flow_leave(2))*cycle/3600;
flow1 = flow_leave(1);
flow2 = flow_leave(2);
flow=flow1+flow2;
n_=n+(flow_5_enter-sum(flow_leave))*cycle/3600;
%% calculate the emission
% judge the current situation: saturated, over-saturated, unsaturated scenario
if q_sum <= sum(mu)*green_time/3600 && sum(mu)*green_time/3600<= flow_5_arriv*cycle/3600+q_sum
%     N_free = max(0, n-cycle/3600*flow_5_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_5_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_5_arriv+q_sum-sum(mu)*green_time/3600; % the vehicles that cannot leave
    N_idl_2 = sum(mu)*green_time/3600-q_sum; % the vehicles that can leave
    N_idl_3 = 0;
    N_idl_4 = q_sum; % the vehicles that can leave
    N_dec = cycle/3600*flow_5_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = cycle/scale - (v_low-v_free)/dec - (v_free-v_low)/acc;
    t_idl_3 = 0;
    t_idl_4 = cycle/scale - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif sum(mu)*green_time/3600<q_sum
%     N_free = max(0, n-cycle/3600*flow_5_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_5_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_5_arriv; % the vehicles that cannot leave
    N_idl_2 = 0;
    N_idl_3 = q_sum-sum(mu)*green_time/3600; % the vehicles that cannot leave
    N_idl_4 = sum(mu)*green_time/3600; % the vehicles that can leave
    N_dec = cycle/3600*flow_5_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = 0;
    t_idl_3 = cycle;
    t_idl_4 = cycle/scale - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif flow_5_arriv*cycle/3600+q_sum<sum(mu)*green_time/3600
    Gs = (cycle/3600*flow_5_arriv+q_sum-green_time/3600*flow_5_arriv)/(sum(mu)-flow_5_arriv)*3600;
    Gd = (green_time/3600*sum(mu)-cycle/3600*flow_5_arriv-q_sum)/(sum(mu)-flow_5_arriv)*3600;
%     N_free = max(0, n-cycle/3600*flow_5_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_5_arriv-q_sum;
    N_idl_1 = 0;
    N_idl_2 = Gs*sum(mu)/3600-q_sum; % the vehicles that can leave
    N_idl_3 = 0;
    N_idl_4 = q_sum; % the vehicles that can leave
    N_dec = (cycle-Gd)*flow_5_arriv/3600;
    N_acc =Gs*sum(mu)/3600;
    N_non = Gd*flow_5_arriv/3600;
    t_free = cycle;
    t_idl_1 = 0;
    t_idl_2 = cycle/scale-Gd/scale-(v_low-v_free)/dec-(v_free-v_low)/acc;
    t_idl_3 = 0;
    t_idl_4 = cycle/scale - Gd/scale - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = Gd/scale;
else
    error('Something goes wrong with the situation judging');
end
if N_free<0
    warning('N_free is 0');
end
% calculate the emissions of all the vehicles
% [CO, HC, NOx, CO2, Fc] = VTmicro(v, a, 2);
e_free = 0.0032;

e_idl = 0.0016;

e_dec = 0.0023;

e_acc = 0.0118;

emission = (N_free*t_free+N_non*t_non).*e_free+(N_idl_1*t_idl_1+N_idl_2*t_idl_2+N_idl_3*t_idl_3+N_idl_4*t_idl_4)*e_idl...
    + N_dec*t_dec*e_dec + N_acc*t_acc*e_acc;

n=n_;
end

