clear; clc; close all
tic
%% Simulation of the traffic network for 1 hour; S-model, cycle=1min
%% define the demands of the source links
% addpath('.\Source');
addpath('.\Source_oneday');
%% define the parameters of all the links
scenario=1;  % the scenarios of demands
% parameters=[5.6986,1824,45.27,621.7,1150.58,725.329,771.39,929,863,1217]';
parameters=[4.1357; 2354.2; 43.51; 671.61; 1104.24; 977.80; 887.358; 798.51; 809.71; 1029.577];
% parameters=[6.236; 2356.323; 40.153; 537.598; 1109.963; 964.947; 837.606; 689.730; 855.036; 1016.662];
% parameters=[5 2000 60 700 1000 800 750 850 900 1200]'; % default value
l_veh=parameters(1); % default: 5m
sat=parameters(2); % saturating flow, default 2000
v_free=parameters(3); % default: 60km/h
v_idl=4;
l_1=parameters(4); % default: 700m
l_2=parameters(5);% default: 1000m
l_3=parameters(6); % default: 800m
l_4=parameters(7); % default: 750m
l_5=parameters(8); % default: 850m
l_6=parameters(9); % default: 900m
l_7=parameters(10); % default: 1200m
% parameter vector [link_length vehicle_lengt free_flow_speed low_speed turning_ratio[left straight right] saturating_flow[left straight right]]
Link_AB=[l_1, l_veh, v_free, v_idl, 2, [0.2 0.8], [sat, sat]]; %parameters of link(A,B), Link_2
Link_BA=[l_1, l_veh, v_free, v_idl, 3, [0.7 0.15 0.15], [sat, sat, sat]]; %parameters of link(A,B), Link_3, left turning ratio is small
Link_BC=[l_1, l_veh, v_free, v_idl, 3, [0.15 0.15 0.7], [sat, sat, sat]]; %parameters of link(B,C), Link_2
Link_CB=[l_1, l_veh, v_free, v_idl, 2, [0.8 0.2], [sat, sat]]; %parameters of link(A,B), Link_2
Link_AD=[l_3, l_veh, v_free, v_idl, 2, [0.4 0.2 0.4] [sat sat sat]];
Link_BE=[l_5, l_veh, v_free, v_idl, 3, [0.25 0.5 0.25], [sat sat sat]];
Link_CF=[l_1, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_DE=[l_4, l_veh, v_free, v_idl, 2, [0.4 0.6], [sat sat]]; % Link_2
Link_ED=[l_4, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]]; %LInk_2
Link_EF=[l_3, l_veh, v_free, v_idl, 1, 1, sat]; %Link_1
Link_FE=[l_3, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_DG=[l_6, l_veh, v_free, v_idl, 2, [0.4 0.6], [sat sat]];
Link_EH=[l_2, l_veh, v_free, v_idl, 3, [0.40 0.20 0.40], [sat sat sat]];
Link_FI=[l_7, l_veh, v_free, v_idl, 2, [0.6 0.4], [sat sat]];
Link_GH=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_HG=[l_2, l_veh, v_free, v_idl, 2, 1, 2*sat]; %Link_1
Link_HI=[l_2, l_veh, v_free, v_idl, 2, 1, 2*sat];
Link_IH=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_1A=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_2A=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_3C=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_4C=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_5I=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_6H=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_7G=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
Link_8D=[l_2, l_veh, v_free, v_idl, 2, [0.5 0.5], [sat sat]];
%% define the initial state of the links
% Capacities
C_AB=floor(Link_AB(1)*Link_AB(5)/Link_AB(2));
C_BA=floor(Link_BA(1)*Link_BA(5)/Link_BA(2));
C_BC=floor(Link_BC(1)*Link_BC(5)/Link_BC(2));
C_CB=floor(Link_CB(1)*Link_CB(5)/Link_CB(2));
C_AD=floor(Link_AD(1)*Link_AD(5)/Link_AD(2));
C_BE=floor(Link_BE(1)*Link_BE(5)/Link_BE(2));
C_CF=floor(Link_CF(1)*Link_CF(5)/Link_CF(2));
C_DE=floor(Link_DE(1)*Link_DE(5)/Link_DE(2));
C_ED=floor(Link_ED(1)*Link_ED(5)/Link_ED(2));
C_EF=floor(Link_EF(1)*Link_EF(5)/Link_EF(2));
C_FE=floor(Link_FE(1)*Link_FE(5)/Link_FE(2));
C_DG=floor(Link_DG(1)*Link_DG(5)/Link_DG(2));
C_EH=floor(Link_EH(1)*Link_EH(5)/Link_EH(2));
C_FI=floor(Link_FI(1)*Link_FI(5)/Link_FI(2));
C_GH=floor(Link_GH(1)*Link_GH(5)/Link_GH(2));
C_HG=floor(Link_HG(1)*Link_HG(5)/Link_HG(2));
C_HI=floor(Link_HI(1)*Link_HI(5)/Link_HI(2));
C_IH=floor(Link_IH(1)*Link_IH(5)/Link_IH(2));
% initial entering
enter_AB_=0;enter_BC_=0;enter_BA_=0;enter_CB_=0;enter_AD_=0;enter_BE_=0;enter_CF_=0;enter_DE_=0;
enter_ED_=0;enter_EF_=0;enter_FE_=0;enter_DG_=0;enter_EH_=0;enter_FI_=0;enter_GH_=0;enter_HG_=0;
enter_HI_=0;enter_IH_=0;
enter_AB__=0;enter_BC__=0;enter_BA__=0;enter_CB__=0;enter_AD__=0;enter_BE__=0;enter_CF__=0;enter_DE__=0;
enter_ED__=0;enter_EF__=0;enter_FE__=0;enter_DG__=0;enter_EH__=0;enter_FI__=0;enter_GH__=0;enter_HG__=0;
enter_HI__=0;enter_IH__=0;
% number of vehicles and queues
n_AB=0;q_AB=[0 0];
n_BA=0;q_BA=[0 0 0];
n_BC=0;q_BC=[0 0 0];
n_CB=0;q_CB=[0 0];
n_AD=0;q_AD=[0 0 0];
n_BE=0;q_BE=[0 0 0];
n_CF=0;q_CF=[0 0];
n_DE=0;q_DE=[0 0];
n_ED=0;q_ED=[0 0];
n_EF=0;q_EF=0;
n_FE=0;q_FE=[0 0];
n_DG=0;q_DG=[0 0];
n_EH=0;q_EH=[0 0 0];
n_FI=0;q_FI=[0 0];
n_GH=0;q_GH=[0 0];
n_HG=0;q_HG=0;
n_HI=0;q_HI=0;
n_IH=0;q_IH=[0 0];
n_1A=0; q_1A=[0 0];
n_2A=0; q_2A=[0 0];
n_3C=0; q_3C=[0 0];
n_4C=0; q_4C=[0 0];
n_5I=0; q_5I=[0 0];
n_6H=0; q_6H=[0 0];
n_7G=0; q_7G=[0 0];
n_8D=0; q_8D=[0 0];
% control variable
hour=12;
N=60*hour; cycle=60;
% green_time=U;
green_time=30*ones(8,N); % 9 intersections, for 60 minutes, 1st row for A, ..., 8th row for I; unit is second
N_total = NaN(1, N);
Emission_total = NaN(1, N);
Q_AB=NaN(1, N);
Q_BA=NaN(1, N);
Q_BC=NaN(1, N);
Q_CB=NaN(1, N);
Q_AD=NaN(1, N);
Q_BE=NaN(1, N);
Q_CF=NaN(1, N);
Q_DE=NaN(1, N);
Q_ED=NaN(1, N);
Q_EF=NaN(1, N);
Q_FE=NaN(1, N);
Q_DG=NaN(1, N);
Q_EH=NaN(1, N);
Q_FI=NaN(1, N);
Q_GH=NaN(1, N);
Q_HG=NaN(1, N);
Q_HI=NaN(1, N);
Q_IH=NaN(1, N);
Q_1A=NaN(1, N);
Q_2A=NaN(1, N);
Q_3C=NaN(1, N);
Q_4C=NaN(1, N);
Q_5I=NaN(1, N);
Q_6H=NaN(1, N);
Q_7G=NaN(1, N);
Q_8D=NaN(1, N);
N_AB=NaN(1, N);
N_BA=NaN(1, N);
N_BC=NaN(1, N);
N_CB=NaN(1, N);
N_AD=NaN(1, N);
N_BE=NaN(1, N);
N_CF=NaN(1, N);
N_DE=NaN(1, N);
N_ED=NaN(1, N);
N_EF=NaN(1, N);
N_FE=NaN(1, N);
N_DG=NaN(1, N);
N_EH=NaN(1, N);
N_FI=NaN(1, N);
N_GH=NaN(1, N);
N_HG=NaN(1, N);
N_HI=NaN(1, N);
N_IH=NaN(1, N);
N_1A=NaN(1, N);
N_2A=NaN(1, N);
N_3C=NaN(1, N);
N_4C=NaN(1, N);
N_5I=NaN(1, N);
N_6H=NaN(1, N);
N_7G=NaN(1, N);
N_8D=NaN(1, N);
Emission_AB=NaN(1, N);
Emission_BA=NaN(1, N);
Emission_BC=NaN(1, N);
Emission_CB=NaN(1, N);
Emission_AD=NaN(1, N);
Emission_BE=NaN(1, N);
Emission_CF=NaN(1, N);
Emission_DE=NaN(1, N);
Emission_ED=NaN(1, N);
Emission_EF=NaN(1, N);
Emission_FE=NaN(1, N);
Emission_DG=NaN(1, N);
Emission_EH=NaN(1, N);
Emission_FI=NaN(1, N);
Emission_GH=NaN(1, N);
Emission_HG=NaN(1, N);
Emission_HI=NaN(1, N);
Emission_IH=NaN(1, N);
Out_1A=NaN(1,N);
Out_2A=NaN(1,N);
Out_3C=NaN(1,N);
Out_4C=NaN(1,N);
Out_5I=NaN(1,N);
Out_6H=NaN(1,N);
Out_7G=NaN(1,N);
Out_8D=NaN(1,N);
%% Simulation for one hour
for k=1:N
C_AB=floor(Link_AB(1)*Link_AB(5)/Link_AB(2));
C_BA=floor(Link_BA(1)*Link_BA(5)/Link_BA(2));
C_BC=floor(Link_BC(1)*Link_BC(5)/Link_BC(2));
C_CB=floor(Link_CB(1)*Link_CB(5)/Link_CB(2));
C_AD=floor(Link_AD(1)*Link_AD(5)/Link_AD(2));
C_BE=floor(Link_BE(1)*Link_BE(5)/Link_BE(2));
C_CF=floor(Link_CF(1)*Link_CF(5)/Link_CF(2));
C_DE=floor(Link_DE(1)*Link_DE(5)/Link_DE(2));
C_ED=floor(Link_ED(1)*Link_ED(5)/Link_ED(2));
C_EF=floor(Link_EF(1)*Link_EF(5)/Link_EF(2));
C_FE=floor(Link_FE(1)*Link_FE(5)/Link_FE(2));
C_DG=floor(Link_DG(1)*Link_DG(5)/Link_DG(2));
C_EH=floor(Link_EH(1)*Link_EH(5)/Link_EH(2));
C_FI=floor(Link_FI(1)*Link_FI(5)/Link_FI(2));
C_GH=floor(Link_GH(1)*Link_GH(5)/Link_GH(2));
C_HG=floor(Link_HG(1)*Link_HG(5)/Link_HG(2));
C_HI=floor(Link_HI(1)*Link_HI(5)/Link_HI(2));
C_IH=floor(Link_IH(1)*Link_IH(5)/Link_IH(2));
    [enter_AB_1, enter_AD_1, n_1A, q_1A, emission_1A] = Link_S1nD(k, n_1A, q_1A, [C_AB, C_AD], green_time(1,k), cycle, Link_1A, scenario); % entering flow from the source
    [enter_AB_2, enter_AD_2, n_2A, q_2A, emission_2A] = Link_S2nD(k, n_2A, q_2A, [C_AB, C_AD], cycle-green_time(1,k), cycle, Link_2A, scenario);
    [enter_CF_3, enter_CB_3, n_3C, q_3C, emission_3C] = Link_S3nD(k, n_3C, q_3C, [C_CF, C_CB], cycle-green_time(2,k), cycle, Link_3C, scenario);
    [enter_CF_4, enter_CB_4, n_4C, q_4C, emission_4C] = Link_S4nD(k, n_4C, q_4C, [C_CF, C_CB], green_time(2,k), cycle, Link_4C, scenario);
    [enter_IH_5, n_5I, q_5I, emission_5I] = Link_S5nD(k, n_5I, q_5I, C_IH, green_time(8,k), cycle, Link_5I, scenario);
    [enter_HG_6, enter_HI_6, n_6H, q_6H, emission_6H] = Link_S6nD(k, n_6H, q_6H, [C_HG, C_HI], cycle-green_time(7,k), cycle, Link_6H, scenario);
    [enter_GH_7, n_7G, q_7G, emission_7G] = Link_S7nD(k, n_7G, q_7G, C_GH, cycle-green_time(6,k), cycle, Link_7G, scenario);
    [enter_DE_8, enter_DG_8, n_8D, q_8D, emission_8D] = Link_S8nD(k, n_8D, q_8D, [C_DE, C_DG], green_time(3, k), cycle, Link_8D, scenario);
%     [enter_AB_1, enter_AD_1] = Link_S1(k, [C_AB, C_AD], green_time(1), cycle); % entering flow from the source
%     [enter_AB_2, enter_AD_2] = Link_S2(k, [C_AB, C_AD], green_time(1), cycle);
%     [enter_CF_3, enter_CB_3] = Link_S3(k, [C_CF, C_CB], green_time(2), cycle);
%     [enter_CF_4, enter_CB_4] = Link_S4(k, [C_CF, C_CB], green_time(2), cycle);
%     enter_IH_5 = Link_S5(k, C_IH, green_time(8), cycle);
%     [enter_HG_6, enter_HI_6] = Link_S6(k, [C_HG, C_HI], green_time(7), cycle);
%     enter_GH_7 = Link_S7(k, C_GH, green_time(6), cycle);
%     [enter_DE_8, enter_DG_8] = Link_S8(k, [C_DE, C_DG], green_time(3), cycle);
%     % simulate from the source links; leave is a vector: leaving to corresponding downstream links
%     enter_AB_1=2*enter_AB_1;
%     enter_AD_1=2*enter_AD_1;
%     enter_AB_2=2*enter_AB_2;
%     enter_AD_2=2*enter_AD_2;
%     enter_CF_3=2*enter_CF_3;
%     enter_CB_3=2*enter_CB_3;
%     enter_CF_4=2*enter_CF_4;
%     enter_CB_4=2*enter_CB_4;
%     enter_IH_5=2*enter_IH_5;
%     enter_HG_6=2*enter_HG_6;
%     enter_HI_6=2*enter_HI_6;
%     enter_GH_7=2*enter_GH_7;
%     enter_DE_8=2*enter_DE_8;
%     enter_DG_8=2*enter_DG_8;
    Out_1A(k)=enter_AB_1+enter_AD_1;
    Out_2A(k)=enter_AB_2+enter_AD_2;
    Out_3C(k)=enter_CF_3+enter_CB_3;
    Out_4C(k)=enter_CF_4+enter_CB_4;
    Out_5I(k)=enter_IH_5;
    Out_6H(k)=enter_HG_6+enter_HI_6;
    Out_7G(k)=enter_GH_7;
    Out_8D(k)=enter_DE_8+enter_DG_8;
    %% link(A,B), B does not need control
    enter_AB = enter_AB_1+enter_AB_2;
    [n_AB, q_AB, leave_AB, emission_AB] = Link2(n_AB, q_AB, [enter_AB__, enter_AB_, enter_AB], cycle, cycle, [C_BC C_BE], Link_AB);%update the state
    leave_AB_C = leave_AB(1); leave_AB_E = leave_AB(2); 
    C_AB=C_AB-n_AB;
    enter_AB__= enter_AB_; enter_AB_= enter_AB; % update the enter of previous step, B does not need control
    %% link(C,B), B does not need control
    enter_CB = enter_CB_3 + enter_CB_4;
    [n_CB, q_CB, leave_CB, emission_CB] = Link2(n_CB, q_CB, [enter_CB__, enter_CB_, enter_CB], cycle, cycle, [C_BE, C_BA], Link_CB);
    leave_CB_E = leave_CB(1); leave_CB_A = leave_CB(2);
    C_CB=C_CB-n_CB;
    enter_CB__ = enter_CB_; enter_CB_ = enter_CB;
    %% link(B,A)
    enter_BA = leave_CB_A;
    [n_BA, q_BA, leave_BA, emission_BA] = Link3(n_BA, q_BA, [enter_BA__, enter_BA_, enter_BA], green_time(1,k), cycle, [C_AD 1000 1000], Link_BA);
    leave_BA_D = leave_BA(1); leave_BA_1=leave_BA(2); leave_BA_2=leave_BA(3);
    C_BA=C_BA-n_BA;
    enter_BA__=enter_BA_; enter_BA_=enter_BA;
    %% link(A,D)
    enter_AD = enter_AD_1+enter_AD_2+leave_BA_D;
    [n_AD, q_AD, leave_AD, emission_AD] = Link3(n_AD, q_AD, [enter_AD__, enter_AD_, enter_AD], cycle-green_time(3,k), cycle, [C_DE C_DG 1000], Link_AD);
    leave_AD_E = leave_AD(1); leave_AD_G = leave_AD(2); leave_AD_8 = leave_AD(3); 
    C_AD=C_AD-n_AD;
    enter_AD__ = enter_AD_;enter_AD_ = enter_AD;
    %% link(B,C)
    enter_BC = leave_AB_C;
    [n_BC, q_BC, leave_BC, emission_BC] = Link3(n_BC, q_BC, [enter_BC__, enter_BC_, enter_BC], green_time(2,k), cycle, [1000, 1000, C_CF], Link_BC);
    leave_BC_3 = leave_BC(1); leave_BC_4 = leave_BC(2); leave_BC_F = leave_BC(3);
    C_BC=C_BC-n_BC;
    enter_BC__=enter_BC_; enter_BC_=enter_BC;
    %% link(C,F)
    enter_CF = enter_CF_3 + enter_CF_4 + leave_BC_F;
    [n_CF, q_CF, leave_CF, emission_CF] = Link2(n_CF, q_CF, [enter_CF__, enter_CF_, enter_CF], cycle-green_time(5,k), cycle, [C_FI, C_FE], Link_CF);
    leave_CF_I = leave_CF(1); leave_CF_E = leave_CF(2);
    C_CF=C_CF-n_CF;
    enter_CF__ = enter_CF_; enter_CF_ = enter_CF;
    %% link(D,E)
    enter_DE = enter_DE_8 + leave_AD_E;
    [n_DE, q_DE, leave_DE, emission_DE] = Link2(n_DE, q_DE, [enter_DE__ enter_DE_ enter_DE], green_time(4,k), cycle, [C_EF, C_EH], Link_DE);
    leave_DE_F = leave_DE(1); leave_DE_H = leave_DE(2);
    C_DE=C_DE-n_DE;
    enter_DE__ = enter_DE_; enter_DE_ = enter_DE;
    %% link(F,E)
    enter_FE = leave_CF_E;
    [n_FE, q_FE, leave_FE, emission_FE] = Link2(n_FE, q_FE, [enter_FE__ enter_FE_ enter_FE], green_time(4,k), cycle, [C_EH, C_ED], Link_FE);
    leave_FE_H = leave_FE(1); leave_FE_D = leave_FE(2);
    C_FE=C_FE-n_FE;
    enter_FE__ = enter_FE_; enter_FE_ = enter_FE;
    %% link(B,E)
    enter_BE = leave_AB_E + leave_CB_E;
    [n_BE, q_BE, leave_BE, emission_BE] = Link3(n_BE, q_BE, [enter_BE__, enter_BE_, enter_BE], cycle-green_time(4,k), cycle, [C_EF, C_EH, C_ED], Link_BE);
    leave_BE_F = leave_BE(1); leave_BE_H = leave_BE(2); leave_BE_D = leave_BE(3);
    C_BE=C_BE-n_BE;
    enter_BE__ = enter_BE_; enter_BE_ = enter_BE;
    %% link(E,D)
    enter_ED = leave_BE_D + leave_FE_D;
    [n_ED, q_ED, leave_ED, emission_ED] = Link2(n_ED, q_ED, [enter_ED__, enter_ED_, enter_ED], green_time(3,k), cycle, [C_DG, 1000], Link_ED);
    leave_ED_G = leave_ED(1); leave_ED_8 = leave_ED(2);
    C_ED=C_ED-n_ED;
    enter_ED__ = enter_ED_; enter_ED_ = enter_ED;
    %% link(D,G)
    enter_DG = enter_DG_8 + leave_AD_G + leave_ED_G;
    [n_DG, q_DG, leave_DG, emission_DG] = Link2(n_DG, q_DG, [enter_DG__, enter_DG_, enter_DG], cycle-green_time(6,k), cycle, [C_GH, 1000], Link_DG);
    leave_DG_H = leave_DG(1); leave_DG_7 = leave_DG(2);
    C_DG=C_DG-n_DG;
    enter_DG__ = enter_DG_; enter_DG_ = enter_DG;
    %% link(G,H)
    enter_GH = enter_GH_7 + leave_DG_H;
    [n_GH, q_GH, leave_GH, emission_GH] = Link2(n_GH, q_GH, [enter_GH__, enter_GH_, enter_GH], green_time(7,k), cycle, [C_HI, 1000], Link_GH);
    leave_GH_I = leave_GH(1); leave_GH_6 = leave_GH(2);
    C_GH=C_GH-n_GH;
    enter_GH__ = enter_GH_; enter_GH_ = enter_GH;
    %% link(E,F)
    enter_EF = leave_BE_F + leave_DE_F;
    [n_EF, q_EF, leave_EF, emission_EF] = Link1(n_EF, q_EF, [enter_EF__, enter_EF_, enter_EF], green_time(5,k), cycle, C_FI, Link_EF);
    leave_EF_I = leave_EF;
    C_EF=C_EF-n_EF;
    enter_EF__ = enter_EF_; enter_EF_ = enter_EF;
    %% link(F,I)
    enter_FI = leave_CF_I + leave_EF_I;
    [n_FI, q_FI, leave_FI, emission_FI] = Link2(n_FI, q_FI, [enter_FI__ enter_FI_ enter_FI], cycle-green_time(8,k), cycle, [1000 C_IH], Link_FI);
    leave_FI_5 = leave_FI(1); leave_FI_H = leave_FI(2);
    C_FI=C_FI-n_FI;
    enter_FI__ = enter_FI_; enter_FI_ = enter_FI;
    %% link(E,H)
    enter_EH = leave_DE_H + leave_BE_H + leave_FE_H;
    [n_EH, q_EH, leave_EH, emission_EH] = Link3(n_EH, q_EH, [enter_EH__ enter_EH_ enter_EH], cycle-green_time(7,k), cycle, [C_HI 1000 C_HG], Link_EH);
    leave_EH_I = leave_EH(1); leave_EH_6 = leave_EH(2); leave_EH_G = leave_EH(3);
    C_EH=C_EH-n_EH;
    enter_EH__ = enter_EH_; enter_EH_ = enter_EH;
    %% link(I,H)
    enter_IH = enter_IH_5 + leave_FI_H;
    [n_IH, q_IH, leave_IH, emission_IH] = Link2(n_IH, q_IH, [enter_IH__ enter_IH_ enter_IH], green_time(7,k), cycle, [1000 C_HG], Link_IH);
    leave_IH_6 = leave_IH(1); leave_IH_G = leave_IH(2);
    C_IH=C_IH-n_IH;
    enter_IH__ = enter_IH_; enter_IH_ = enter_IH;
    %% link(H,G)
    enter_HG = leave_EH_G + leave_IH_G + enter_HG_6;
    [n_HG, q_HG, leave_HG, emission_HG] = Link1(n_HG, q_HG, [enter_HG__ enter_HG_ enter_HG], green_time(6,k), cycle, 1000, Link_HG);
    leave_HG_7 = leave_HG;
    C_HG=C_HG-n_HG;
    enter_HG__ = enter_HG_; enter_HG_ = enter_HG;
    %% link(H,I)
    enter_HI = leave_EH_I + leave_GH_I + enter_HI_6;
    [n_HI, q_HI, leave_HI, emission_HI] = Link1(n_HI, q_HI, [enter_HI__ enter_HI_ enter_HI], green_time(8,k), cycle, 1000, Link_HI);
    leave_HI_5 = leave_HI;
    C_HI=C_HI-n_HI;
    enter_HI__ = enter_HI_; enter_HI_ = enter_HI;
    %% 
    Emission = emission_AB+emission_BA+emission_BC+emission_CB+emission_AD+emission_BE+emission_CF+emission_DE+emission_ED...
        +emission_EF+emission_FE+emission_DG+emission_EH+emission_FI+emission_GH+emission_HG+emission_HI+emission_IH+emission_1A+...
        emission_2A+emission_3C+emission_4C+emission_5I+emission_6H+emission_7G+emission_8D;
    Emission_total(k) = Emission;
    Q_AB(k)=sum(q_AB);Q_BA(k)=sum(q_BA);Q_BC(k)=sum(q_BC);Q_CB(k)=sum(q_CB);Q_AD(k)=sum(q_AD);Q_BE(k)=sum(q_BE);
    Q_CF(k)=sum(q_CF);Q_DE(k)=sum(q_DE);Q_ED(k)=sum(q_ED);Q_EF(k)=sum(q_EF);Q_FE(k)=sum(q_FE);Q_DG(k)=sum(q_DG);
    Q_EH(k)=sum(q_EH);Q_FI(k)=sum(q_FI);Q_GH(k)=sum(q_GH);Q_HG(k)=sum(q_HG);Q_HI(k)=sum(q_HI);Q_IH(k)=sum(q_IH);
%     Q_1A(k)=sum(q_1A);Q_2A(k)=sum(q_2A);Q_3C(k)=sum(q_3C);Q_4C(k)=sum(q_4C);Q_5I(k)=sum(q_5I);Q_6H(k)=sum(q_6H);
%     Q_7G(k)=sum(q_7G);Q_8D(k)=sum(q_8D);
    n_total = n_AB + n_BA + n_BC + n_CB + n_AD + n_BE + n_CF + n_DE + n_ED + n_EF + n_FE + n_DG + n_EH + n_FI + n_GH...
        + n_HG + n_HI + n_IH +n_1A+n_2A+n_3C+n_4C+n_5I+n_6H+n_7G+n_8D;
    Emission_AB(k) = emission_AB; Emission_BA(k) = emission_BA; Emission_BC(k) = emission_BC; Emission_CB(k) = emission_CB; Emission_AD(k) = emission_AD;
    Emission_BE(k) = emission_BE; Emission_CF(k) = emission_CF; Emission_DE(k) = emission_DE; Emission_ED(k) = emission_ED; Emission_EF(k) = emission_EF; 
    Emission_FE(k) = emission_FE; Emission_DG(k) = emission_DG; Emission_EH(k) = emission_EH; Emission_FI(k) = emission_FI; 
    Emission_GH(k) = emission_GH; Emission_HG(k) = emission_HG; Emission_HI(k) = emission_HI; Emission_IH(k) = emission_IH;
    N_AB(k) = n_AB; N_BA(k) = n_BA; N_BC(k) = n_BC; N_CB(k) = n_CB; N_AD(k) = n_AD; N_BE(k) = n_BE; 
    N_CF(k) = n_CF; N_DE(k) = n_DE; N_ED(k) = n_ED; N_EF(k) = n_EF; N_FE(k) = n_FE; N_DG(k) = n_DG; 
    N_EH(k) = n_EH; N_FI(k) = n_FI; N_GH(k) = n_GH; N_HG(k) = n_HG; N_HI(k) = n_HI; N_IH(k) = n_IH;
    N_1A(k)=n_1A;N_2A(k)=n_2A;N_3C(k)=n_3C;N_4C(k)=n_4C;N_5I(k)=n_5I;N_6H(k)=n_6H;N_7G(k)=n_7G;
    N_8D(k)=n_8D;
    N_total(k) = n_total;
end
toc
%%
tt=1:60*hour;
TTS = sum(N_total)/60;
TE = sum(Emission_total); % total emission
fprintf('The total time spent is\n%.3f hours\n', TTS);
fprintf('The total emission of CO2 is\n%.3f kg\n', TE);

figure();
plot(tt/60, N_total, '*-', 'linewidth', 1.5);
xlabel('hour'); ylabel('vehicle');
title('Total vehicles on the network every step');

figure();
plot(tt/60, Emission_total, '*-', 'linewidth', 1.5);
xlabel('hour'); ylabel('kg');
title('Total emissions of CO_2 on the network every step');

figure();
plot(tt, Q_AB, '*-', tt, Q_BA, '*-', tt, Q_BC, '*-', tt, Q_CB, '*-', tt, Q_AD, '*-', tt, Q_BE, '*-', tt, Q_CF, '*-', tt, Q_DE, '*-', tt, Q_ED, '*-', tt, Q_EF, '*-', tt, Q_FE, '*-', tt, Q_DG...
    , '*-', tt, Q_EH, '*-', tt, Q_FI, '*-', tt, Q_GH, '*-', tt, Q_HG, 'o-', tt, Q_HI, 'o-', tt, Q_IH, '*-');
xlabel('min'); ylabel('vehicle');
title('Queue length of every link');
legend('Q-AB','Q-BA','Q-BC','Q-CB','Q-AD','Q-BE','Q-CF','Q-DE','Q-ED','Q-EF','Q-FE','Q-DG','Q-EH','Q-FI','Q-GH','Q-HG','Q-HI','Q-IH');
