function [flow1, flow2, n, q, emission, entering] = Link_S1nD_noise( t, n, q, c, green_time, cycle, para, scenario )
%LINK_S1 generate the demand flow of source 1, varying flow 
%   c is the available capacity of the downstream links (vector)
% beta=[0.5 0.5]; % the turning ratio of the current link to the downstream links

l_link = para(1); % link length
l_veh = para(2); % vehicle length
v_free = para(3)/3.6; % free flow speed, m/s
v_low = para(4)/3.6; % low speed, m/s
N_lane = para(5); % number of lanes of link
beta = para(6:7); % turning ratio for 1, 2
mu = para(8:9); % saturating flow rate for turning 1,2  
q_sum=sum(q);
C = floor(N_lane*l_link/l_veh); % the maximum capacity of the link
acc=2; %accelaration m/s2, speed up
dec=-2; %accelaration m/s2, slow down
tao = floor(((C-q_sum)*l_veh)/(N_lane*v_free*cycle)); % delayed cycle
gama = rem(l_veh*(C-q_sum)/(N_lane*v_free), cycle); % delayed seconds
if tao<0
    gama=0; tao=0;
end
switch scenario
    case 0
        flow_1_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60)+1440.*(t>=61 & t<=120)+1350.*(t>=121 & t<=180)+1350.*(t>=181 & t<=240)...
        +1280.*(t>=241 & t<=300) + 1280.*(t>=301 & t<=360) + 1100.*(t>=361 & t<=420) + 1100.*(t>=421 & t<=480)+...
        1000.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 900.*(t>=601 & t<=660) + 800.*(t>=661 & t<=720)+...
        700.*(t>=721 & t<=780) + 700.*(t>=781 & t<=840) + 600.*(t>=841 & t<=900) + 600.*(t>=901 & t<=960)+...
        900.*(t>=961 & t<=1020) + 1200.*(t>=1021 & t<=1080) + 1300.*(t>=1081 & t<=1140) + 800.*(t>=1141 & t<=1200)...
        +1000.*(t>=1201 & t<=1260) + 1200.*(t>=1261 & t<=1320) + 1300.*(t>=1321 & t<=1380) + 1440.*(t>=1381 & t<=1440); % varying source flow
        t_=t-1;
        flow_1_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60)+1440.*(t_>=61 & t_<=120)+1350.*(t_>=121 & t_<=180)+1350.*(t_>=181 & t_<=240)...
        +1280.*(t_>=241 & t_<=300) + 1280.*(t_>=301 & t_<=360) + 1100.*(t_>=361 & t_<=420) + 1100.*(t_>=421 & t_<=480)+...
        1000.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 900.*(t_>=601 & t_<=660) + 800.*(t_>=661 & t_<=720)+...
        700.*(t_>=721 & t_<=780) + 700.*(t_>=781 & t_<=840) + 600.*(t_>=841 & t_<=900) + 600.*(t_>=901 & t_<=960)+...
        900.*(t_>=961 & t_<=1020) + 1200.*(t_>=1021 & t_<=1080) + 1300.*(t_>=1081 & t_<=1140) + 800.*(t_>=1141 & t_<=1200)...
        +1000.*(t_>=1201 & t_<=1260) + 1200.*(t_>=1261 & t_<=1320) + 1300.*(t_>=1321 & t_<=1380) + 1440.*(t_>=1381 & t_<=1440);
        t__=t_-1;
        flow_1_enter__ =  0.*(t__<=0)+1440.*(t__>=1 & t__<=60)+1440.*(t__>=61 & t__<=120)+1350.*(t__>=121 & t__<=180)+1350.*(t__>=181 & t__<=240)...
        +1280.*(t__>=241 & t__<=300) + 1280.*(t__>=301 & t__<=360) + 1100.*(t__>=361 & t__<=420) + 1100.*(t__>=421 & t__<=480)+...
        1000.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 900.*(t__>=601 & t__<=660) + 800.*(t__>=661 & t__<=720)+...
        700.*(t__>=721 & t__<=780) + 700.*(t__>=781 & t__<=840) + 600.*(t__>=841 & t__<=900) + 600.*(t__>=901 & t__<=960)+...
        900.*(t__>=961 & t__<=1020) + 1200.*(t__>=1021 & t__<=1080) + 1300.*(t__>=1081 & t__<=1140) + 800.*(t__>=1141 & t__<=1200)...
        +1000.*(t__>=1201 & t__<=1260) + 1200.*(t__>=1261 & t__<=1320) + 1300.*(t__>=1321 & t__<=1380) + 1440.*(t__>=1381 & t__<=1440);
    case 1
        flow_1_enter = 800.*(t<=360)+ 800.*(t>=361 & t<=420) + 1000.*(t>=421 & t<=480)+...
        1200.*(t>=481 & t<=540) + 1440.*(t>=541 & t<=600) + 1440.*(t>=601 & t<=660) + 1000.*(t>=661 & t<=720)...
        + 0.*(t>=720)+10*sin(10*t); % varying source flow
        t_=t-1;
        flow_1_enter_ = 800.*(t_<=360)+ 800.*(t_>=361 & t_<=420) + 1000.*(t_>=421 & t_<=480)+...
        1200.*(t_>=481 & t_<=540) + 1440.*(t_>=541 & t_<=600) + 1440.*(t_>=601 & t_<=660) + 1000.*(t_>=661 & t_<=720)...
        + 0.*(t_>=720)+10*sin(10*t_);
        t__=t_-1;
        flow_1_enter__ =  800.*(t__<=360)+ 800.*(t__>=361 & t__<=420) + 1000.*(t__>=421 & t__<=480)+...
        1200.*(t__>=481 & t__<=540) + 1440.*(t__>=541 & t__<=600) + 1440.*(t__>=601 & t__<=660) + 1000.*(t__>=661 & t__<=720)...
        + 0.*(t__>=720)+10*sin(10*t__);
    case 2
        flow_1_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60)+1440.*(t>=61 & t<=120)+1350.*(t>=121 & t<=180)+1350.*(t>=181 & t<=240)...
        +1280.*(t>=241 & t<=300) + 1280.*(t>=301 & t<=360) + 1100.*(t>=361 & t<=420) + 1100.*(t>=421 & t<=480)+...
        1000.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 900.*(t>=601 & t<=660) + 800.*(t>=661 & t<=720)+...
        700.*(t>=721 & t<=780) + 700.*(t>=781 & t<=840) + 600.*(t>=841 & t<=900) + 600.*(t>=901 & t<=960)+...
        900.*(t>=961 & t<=1020) + 1200.*(t>=1021 & t<=1080) + 1300.*(t>=1081 & t<=1140) + 800.*(t>=1141 & t<=1200)...
        +1000.*(t>=1201 & t<=1260) + 1200.*(t>=1261 & t<=1320) + 1300.*(t>=1321 & t<=1380) + 1440.*(t>=1381 & t<=1440)+10.*sin(t*10); % varying source flow
        t_=t-1;
        flow_1_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60)+1440.*(t_>=61 & t_<=120)+1350.*(t_>=121 & t_<=180)+1350.*(t_>=181 & t_<=240)...
        +1280.*(t_>=241 & t_<=300) + 1280.*(t_>=301 & t_<=360) + 1100.*(t_>=361 & t_<=420) + 1100.*(t_>=421 & t_<=480)+...
        1000.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 900.*(t_>=601 & t_<=660) + 800.*(t_>=661 & t_<=720)+...
        700.*(t_>=721 & t_<=780) + 700.*(t_>=781 & t_<=840) + 600.*(t_>=841 & t_<=900) + 600.*(t_>=901 & t_<=960)+...
        900.*(t_>=961 & t_<=1020) + 1200.*(t_>=1021 & t_<=1080) + 1300.*(t_>=1081 & t_<=1140) + 800.*(t_>=1141 & t_<=1200)...
        +1000.*(t_>=1201 & t_<=1260) + 1200.*(t_>=1261 & t_<=1320) + 1300.*(t_>=1321 & t_<=1380) + 1440.*(t_>=1381 & t_<=1440)+10.*sin(t_*10);
        t__=t_-1;
        flow_1_enter__ =  0.*(t__<=0)+1440.*(t__>=1 & t__<=60)+1440.*(t__>=61 & t__<=120)+1350.*(t__>=121 & t__<=180)+1350.*(t__>=181 & t__<=240)...
        +1280.*(t__>=241 & t__<=300) + 1280.*(t__>=301 & t__<=360) + 1100.*(t__>=361 & t__<=420) + 1100.*(t__>=421 & t__<=480)+...
        1000.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 900.*(t__>=601 & t__<=660) + 800.*(t__>=661 & t__<=720)+...
        700.*(t__>=721 & t__<=780) + 700.*(t__>=781 & t__<=840) + 600.*(t__>=841 & t__<=900) + 600.*(t__>=901 & t__<=960)+...
        900.*(t__>=961 & t__<=1020) + 1200.*(t__>=1021 & t__<=1080) + 1300.*(t__>=1081 & t__<=1140) + 800.*(t__>=1141 & t__<=1200)...
        +1000.*(t__>=1201 & t__<=1260) + 1200.*(t__>=1261 & t__<=1320) + 1300.*(t__>=1321 & t__<=1380) + 1440.*(t__>=1381 & t__<=1440)+10.*sin(t__*10);
    case 3
        flow_1_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60)+1440.*(t>=61 & t<=120)+1350.*(t>=121 & t<=180)+1350.*(t>=181 & t<=240)...
        +1280.*(t>=241 & t<=300) + 1280.*(t>=301 & t<=360) + 1100.*(t>=361 & t<=420) + 1100.*(t>=421 & t<=480)+...
        1000.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 900.*(t>=601 & t<=660) + 800.*(t>=661 & t<=720)+...
        700.*(t>=721 & t<=780) + 700.*(t>=781 & t<=840) + 600.*(t>=841 & t<=900) + 600.*(t>=901 & t<=960)+...
        900.*(t>=961 & t<=1020) + 1200.*(t>=1021 & t<=1080) + 1300.*(t>=1081 & t<=1140) + 800.*(t>=1141 & t<=1200)...
        +1000.*(t>=1201 & t<=1260) + 1200.*(t>=1261 & t<=1320) + 1300.*(t>=1321 & t<=1380) + 1440.*(t>=1381 & t<=1440)+10*sin(10*t); % varying source flow
        t_=t-1;
        flow_1_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60)+1440.*(t_>=61 & t_<=120)+1350.*(t_>=121 & t_<=180)+1350.*(t_>=181 & t_<=240)...
        +1280.*(t_>=241 & t_<=300) + 1280.*(t_>=301 & t_<=360) + 1100.*(t_>=361 & t_<=420) + 1100.*(t_>=421 & t_<=480)+...
        1000.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 900.*(t_>=601 & t_<=660) + 800.*(t_>=661 & t_<=720)+...
        700.*(t_>=721 & t_<=780) + 700.*(t_>=781 & t_<=840) + 600.*(t_>=841 & t_<=900) + 600.*(t_>=901 & t_<=960)+...
        900.*(t_>=961 & t_<=1020) + 1200.*(t_>=1021 & t_<=1080) + 1300.*(t_>=1081 & t_<=1140) + 800.*(t_>=1141 & t_<=1200)...
        +1000.*(t_>=1201 & t_<=1260) + 1200.*(t_>=1261 & t_<=1320) + 1300.*(t_>=1321 & t_<=1380) + 1440.*(t_>=1381 & t_<=1440)+10*sin(10*t_);
        t__=t_-1;
        flow_1_enter__ =  0.*(t__<=0)+1440.*(t__>=1 & t__<=60)+1440.*(t__>=61 & t__<=120)+1350.*(t__>=121 & t__<=180)+1350.*(t__>=181 & t__<=240)...
        +1280.*(t__>=241 & t__<=300) + 1280.*(t__>=301 & t__<=360) + 1100.*(t__>=361 & t__<=420) + 1100.*(t__>=421 & t__<=480)+...
        1000.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 900.*(t__>=601 & t__<=660) + 800.*(t__>=661 & t__<=720)+...
        700.*(t__>=721 & t__<=780) + 700.*(t__>=781 & t__<=840) + 600.*(t__>=841 & t__<=900) + 600.*(t__>=901 & t__<=960)+...
        900.*(t__>=961 & t__<=1020) + 1200.*(t__>=1021 & t__<=1080) + 1300.*(t__>=1081 & t__<=1140) + 800.*(t__>=1141 & t__<=1200)...
        +1000.*(t__>=1201 & t__<=1260) + 1200.*(t__>=1261 & t__<=1320) + 1300.*(t__>=1321 & t__<=1380) + 1440.*(t__>=1381 & t__<=1440)+10*sin(10*t__);
    case 4
        flow_1_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60)+1440.*(t>=61 & t<=120)+1350.*(t>=121 & t<=180)+1350.*(t>=181 & t<=240)...
        +1280.*(t>=241 & t<=300) + 1280.*(t>=301 & t<=360) + 1100.*(t>=361 & t<=420) + 1100.*(t>=421 & t<=480)+...
        1000.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 900.*(t>=601 & t<=660) + 800.*(t>=661 & t<=720)+...
        700.*(t>=721 & t<=780) + 700.*(t>=781 & t<=840) + 600.*(t>=841 & t<=900) + 600.*(t>=901 & t<=960)+...
        900.*(t>=961 & t<=1020) + 1200.*(t>=1021 & t<=1080) + 1300.*(t>=1081 & t<=1140) + 800.*(t>=1141 & t<=1200)...
        +1000.*(t>=1201 & t<=1260) + 1200.*(t>=1261 & t<=1320) + 1300.*(t>=1321 & t<=1380) + 1440.*(t>=1381 & t<=1440)+10*sin(10*t); % varying source flow
        t_=t-1;
        flow_1_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60)+1440.*(t_>=61 & t_<=120)+1350.*(t_>=121 & t_<=180)+1350.*(t_>=181 & t_<=240)...
        +1280.*(t_>=241 & t_<=300) + 1280.*(t_>=301 & t_<=360) + 1100.*(t_>=361 & t_<=420) + 1100.*(t_>=421 & t_<=480)+...
        1000.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 900.*(t_>=601 & t_<=660) + 800.*(t_>=661 & t_<=720)+...
        700.*(t_>=721 & t_<=780) + 700.*(t_>=781 & t_<=840) + 600.*(t_>=841 & t_<=900) + 600.*(t_>=901 & t_<=960)+...
        900.*(t_>=961 & t_<=1020) + 1200.*(t_>=1021 & t_<=1080) + 1300.*(t_>=1081 & t_<=1140) + 800.*(t_>=1141 & t_<=1200)...
        +1000.*(t_>=1201 & t_<=1260) + 1200.*(t_>=1261 & t_<=1320) + 1300.*(t_>=1321 & t_<=1380) + 1440.*(t_>=1381 & t_<=1440)+10*sin(10*t_);
        t__=t_-1;
        flow_1_enter__ =  0.*(t__<=0)+1440.*(t__>=1 & t__<=60)+1440.*(t__>=61 & t__<=120)+1350.*(t__>=121 & t__<=180)+1350.*(t__>=181 & t__<=240)...
        +1280.*(t__>=241 & t__<=300) + 1280.*(t__>=301 & t__<=360) + 1100.*(t__>=361 & t__<=420) + 1100.*(t__>=421 & t__<=480)+...
        1000.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 900.*(t__>=601 & t__<=660) + 800.*(t__>=661 & t__<=720)+...
        700.*(t__>=721 & t__<=780) + 700.*(t__>=781 & t__<=840) + 600.*(t__>=841 & t__<=900) + 600.*(t__>=901 & t__<=960)+...
        900.*(t__>=961 & t__<=1020) + 1200.*(t__>=1021 & t__<=1080) + 1300.*(t__>=1081 & t__<=1140) + 800.*(t__>=1141 & t__<=1200)...
        +1000.*(t__>=1201 & t__<=1260) + 1200.*(t__>=1261 & t__<=1320) + 1300.*(t__>=1321 & t__<=1380) + 1440.*(t__>=1381 & t__<=1440)+10*sin(10*t__);
    case 5
        flow_1_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60)+1440.*(t>=61 & t<=120)+1350.*(t>=121 & t<=180)+1350.*(t>=181 & t<=240)...
        +1280.*(t>=241 & t<=300) + 1280.*(t>=301 & t<=360) + 1100.*(t>=361 & t<=420) + 1100.*(t>=421 & t<=480)+...
        1000.*(t>=481 & t<=540) + 1000.*(t>=541 & t<=600) + 900.*(t>=601 & t<=660) + 800.*(t>=661 & t<=720)+...
        700.*(t>=721 & t<=780) + 700.*(t>=781 & t<=840) + 600.*(t>=841 & t<=900) + 600.*(t>=901 & t<=960)+...
        900.*(t>=961 & t<=1020) + 1200.*(t>=1021 & t<=1080) + 1300.*(t>=1081 & t<=1140) + 800.*(t>=1141 & t<=1200)...
        +1000.*(t>=1201 & t<=1260) + 1200.*(t>=1261 & t<=1320) + 1300.*(t>=1321 & t<=1380) + 1440.*(t>=1381 & t<=1440)+10*sin(10*t); % varying source flow
        t_=t-1;
        flow_1_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60)+1440.*(t_>=61 & t_<=120)+1350.*(t_>=121 & t_<=180)+1350.*(t_>=181 & t_<=240)...
        +1280.*(t_>=241 & t_<=300) + 1280.*(t_>=301 & t_<=360) + 1100.*(t_>=361 & t_<=420) + 1100.*(t_>=421 & t_<=480)+...
        1000.*(t_>=481 & t_<=540) + 1000.*(t_>=541 & t_<=600) + 900.*(t_>=601 & t_<=660) + 800.*(t_>=661 & t_<=720)+...
        700.*(t_>=721 & t_<=780) + 700.*(t_>=781 & t_<=840) + 600.*(t_>=841 & t_<=900) + 600.*(t_>=901 & t_<=960)+...
        900.*(t_>=961 & t_<=1020) + 1200.*(t_>=1021 & t_<=1080) + 1300.*(t_>=1081 & t_<=1140) + 800.*(t_>=1141 & t_<=1200)...
        +1000.*(t_>=1201 & t_<=1260) + 1200.*(t_>=1261 & t_<=1320) + 1300.*(t_>=1321 & t_<=1380) + 1440.*(t_>=1381 & t_<=1440)+10*sin(10*t_);
        t__=t_-1;
        flow_1_enter__ =  0.*(t__<=0)+1440.*(t__>=1 & t__<=60)+1440.*(t__>=61 & t__<=120)+1350.*(t__>=121 & t__<=180)+1350.*(t__>=181 & t__<=240)...
        +1280.*(t__>=241 & t__<=300) + 1280.*(t__>=301 & t__<=360) + 1100.*(t__>=361 & t__<=420) + 1100.*(t__>=421 & t__<=480)+...
        1000.*(t__>=481 & t__<=540) + 1000.*(t__>=541 & t__<=600) + 900.*(t__>=601 & t__<=660) + 800.*(t__>=661 & t__<=720)+...
        700.*(t__>=721 & t__<=780) + 700.*(t__>=781 & t__<=840) + 600.*(t__>=841 & t__<=900) + 600.*(t__>=901 & t__<=960)+...
        900.*(t__>=961 & t__<=1020) + 1200.*(t__>=1021 & t__<=1080) + 1300.*(t__>=1081 & t__<=1140) + 800.*(t__>=1141 & t__<=1200)...
        +1000.*(t__>=1201 & t__<=1260) + 1200.*(t__>=1261 & t__<=1320) + 1300.*(t__>=1321 & t__<=1380) + 1440.*(t__>=1381 & t__<=1440)+10*sin(10*t__);
end

    enter=[flow_1_enter__ flow_1_enter_ flow_1_enter];
    entering=flow_1_enter;
flow_1_arriv = (cycle-gama)/cycle*enter(end-tao) + gama/cycle*enter(end-tao-1); % arriving flow at current cycle
% flow_1 = 800.*(t>=0 & t<240)+(1500).*(t>=240 & t<300)+(2330).*(t>=300 & t<360)+(2720).*(t>=360 & t<420)+3020.*(t>=420 & t<480)...
%     +3130.*(t>=480 & t<540) + 1970.*(t>=540 & t<600) + 1480.*(t>=600 & t<660) + 1480.*(t>=660 & t<700) + 3440.*(t>=700 & t<780)...
%     + 1520.*(t>=780 & t<840) + 1470.*(t>=840 & t<900) + 1250.*(t>=900 & t<966) + 2170.*(t>=966 & t<1005) + 3080.*(t>=1005 & t<1060)...
%     + 2780.*(t>=1060 & t<1100) + 1870.*(t>=1100 & t<1200) + 2140.*(t>=1200 & t<1260) + 1450.*(t>=1260 & t<1320)...
%     +1130.*(t>=1320 & t<1380) + 800.*(t>=1380 & t<1440);


flow_arriv(1)=flow_1_arriv*beta(1);
flow_arriv(2)=flow_1_arriv*beta(2);

flow_leave(1)=min([(green_time/cycle)*mu(1), flow_arriv(1)+q(1)/cycle*3600, beta(1)*c(1)/cycle*3600]);
flow_leave(2)=min([(green_time/cycle)*mu(2), flow_arriv(2)+q(2)/cycle*3600, beta(2)*c(2)/cycle*3600]);
q(1)=q(1)+(flow_arriv(1)-flow_leave(1))*cycle/3600;
q(2)=q(2)+(flow_arriv(2)-flow_leave(2))*cycle/3600;
flow1 = flow_leave(1);
flow2 = flow_leave(2);
n_=n+(flow_1_enter-sum(flow_leave))*cycle/3600;
%% calculate the emission
% judge the current situation: saturated, over-saturated, unsaturated scenario
if q_sum <= sum(mu)*green_time/3600 && sum(mu)*green_time/3600<= flow_1_arriv*cycle/3600+q_sum
%     N_free = max(-1, n-cycle/3600*flow_1_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_1_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_1_arriv+q_sum-sum(mu)*green_time/3600;
    N_idl_2 = sum(mu)*green_time/3600-q_sum;
    N_idl_3 = 0;
    N_idl_4 = q_sum;
    N_dec = cycle/3600*flow_1_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = cycle - (v_low-v_free)/dec - (v_free-v_low)/acc;
    t_idl_3 = 0;
    t_idl_4 = cycle - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif sum(mu)*green_time/3600<q_sum
%     N_free = max(-1, n-cycle/3600*flow_1_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_1_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_1_arriv;
    N_idl_2 = 0;
    N_idl_3 = q_sum-sum(mu)*green_time/3600;
    N_idl_4 = sum(mu)*green_time/3600;
    N_dec = cycle/3600*flow_1_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = 0;
    t_idl_3 = cycle;
    t_idl_4 = cycle - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif flow_1_arriv*cycle/3600+q_sum<sum(mu)*green_time/3600
    Gs = (cycle/3600*flow_1_arriv+q_sum-green_time/3600*flow_1_arriv)/(sum(mu)-flow_1_arriv)*3600;
    Gd = (green_time/3600*sum(mu)-cycle/3600*flow_1_arriv-q_sum)/(sum(mu)-flow_1_arriv)*3600;
%     N_free = max(-1, n-cycle/3600*flow_1_arriv-q_sum);
    
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_1_arriv-q_sum;
    N_idl_1 = 0;
    N_idl_2 = Gs*sum(mu)/3600-q_sum;
    N_idl_3 = 0;
    N_idl_4 = q_sum;
    N_dec = (cycle-Gd)*flow_1_arriv/3600;
    N_acc =Gs*sum(mu)/3600;
    N_non = Gd*flow_1_arriv/3600;
    t_free = cycle;
    t_idl_1 = 0;
    t_idl_2 = max(0, cycle-Gd-(v_low-v_free)/dec-(v_free-v_low)/acc);
    t_idl_3 = 0;
    t_idl_4 = max(0, cycle - Gd - (v_free-v_low)/acc);
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = Gd;
else
    error('Something goes wrong with the situation judging');
end
if N_free<0
    warning('N_free is 0');
end
% calculate the emissions of all the vehicles
% [CO, HC, NOx, CO2, Fc] = VTmicro(v, a, 2);
e_free = VTmicro(v_free, 0, 2);

e_idl = VTmicro(v_low, 0, 2);

e_dec = VTmicro((v_free+v_low)/2, dec, 2);

e_acc = VTmicro((v_free+v_low)/2, acc, 2);

emission = (N_free*t_free+N_non*t_non).*e_free+(N_idl_1*t_idl_1+N_idl_2*t_idl_2+N_idl_3*t_idl_3+N_idl_4*t_idl_4)*e_idl...
    + N_dec*t_dec*e_dec + N_acc*t_acc*e_acc;
n=n_;
% if n<0
%     warning('N is 0');
% end
end

