function [flow1, flow2, n, q, emission] = Link_S4nLD( t, n, q, c, green_time, cycle, para, scale, scenario )
%LINK_S4 Constant source link 
%   c is the available capacity of the downstream links (vector)
% beta=[0.5 0.5]; % the turning ratio of the current link to the downstream links
% flow_4 = 6500/5.*(t>=1 & t<2) + 9000/5.*(t>=2 & t<3) + 10000/5.*(t>=3 & t<8) + 5*1000/5.*(t>=8); % constant source flow
% flow_4 = 10*2000/10.*(t>=1 & t<4) + 5*(2000+1000)/10.*(t>=4 & t<5) + 10*1000/10.*(t>=5); % constant source flow
% t=t-1;
% flow_4 = 72600/60.*(t>=0 & t<6) + 92200/60.*(t>=6 & t<7) + 131400/60.*(t>=7 & t<8) + 88600/60.*(t>=8 & t<9) + 67200/60.*(t>=9 & t<11)...
%     + 104800/60.*(t>=11 & t<12) + 93810/60.*(t>=12 & t<13) + 64020/60.*(t>=13 & t<17) + 100830/60.*(t>=17 & t<18)...
%     + 137640/60.*(t>=18 & t<19) + 52200/60.*(t>=19 & t<24);
% flow_4 = flow_4*60;  
% if c(1)>=1 && c(2)>=1
%     flow(1)=flow_4*beta(1);
%     flow(2)=flow_4*beta(2);
% elseif c(1)>=1 && c(2)<1
%     flow(1)=flow_4*beta(1);
%     flow(2)=0;
% elseif c(1)<1 && c(2)>=1
%     flow(1)=0;
%     flow(2)=flow_4*beta(2);
% else
%     flow(1)=0;
%     flow(2)=0;
% end
% 
% flow(1)=(green_time/cycle)*flow(1);
% flow(2)=(green_time/cycle)*flow(2);
% 
% flow1 = flow(1);
% flow2 = flow(2);
l_link = para(1); % link length
l_veh = para(2); % vehicle length
v_free = para(3)/3.6; % free flow speed, m/s
v_low = para(4)/3.6; % low speed, m/s
N_lane = para(5); % number of lanes of link
beta = para(6:7); % turning ratio for 1, 2
mu = para(8:9); % saturating flow rate for turning 1,2  
C = floor(N_lane*l_link/l_veh)*scale; % the maximum capacity of the link
q_sum=sum(q);
acc=2; %accelaration m/s2, speed up
dec=-2; %accelaration m/s2, slow down
tao = floor(((C-q_sum)*l_veh/scale)/(N_lane*v_free*cycle)); % delayed cycle
gama = rem(l_veh*(C-q_sum)/scale/(N_lane*v_free), cycle); % delayed seconds
if tao<0
    gama=0; tao=0;
end
switch scenario
    case 0
        flow_4_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60/scale) + 1440.*(t>=60/scale+1 & t<=2*60/scale) + 1350.*(t>=2*60/scale+1 & t<=3*60/scale) + 1350.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +1280.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1280.*(t>=5*60/scale+1 & t<=6*60/scale)+1100.*(t>=6*60/scale+1 & t<=7*60/scale)+1100.*(t>=7*60/scale+1 & t<=8*60/scale)+1000.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+900.*(t>=10*60/scale+1 & t<=11*60/scale)+800.*(t>=11*60/scale+1 & t<=12*60/scale)+700.*(t>=12*60/scale+1 & t<=13*60/scale)+700.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +600.*(t>=14*60/scale+1 & t<=15*60/scale)+600.*(t>=15*60/scale+1 & t<=16*60/scale)+900.*(t>=16*60/scale+1 & t<=17*60/scale)+1200.*(t>=17*60/scale+1 & t<=18*60/scale)+1300.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +800.*(t>=19*60/scale+1 & t<=20*60/scale) + 1000.*(t>=20*60/scale+1 & t<=21*60/scale) + 1200.*(t>=21*60/scale+1 & t<=22*60/scale) + 1300.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +1440.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_4_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60/scale) + 1440.*(t_>=60/scale+1 & t_<=2*60/scale) + 1350.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 1350.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +1280.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1280.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1100.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1100.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1000.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+900.*(t_>=10*60/scale+1 & t_<=11*60/scale)+800.*(t_>=11*60/scale+1 & t_<=12*60/scale)+700.*(t_>=12*60/scale+1 & t_<=13*60/scale)+700.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +600.*(t_>=14*60/scale+1 & t_<=15*60/scale)+600.*(t_>=15*60/scale+1 & t_<=16*60/scale)+900.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1200.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1300.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +800.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1000.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 1200.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 1300.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +1440.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_4_enter__ = 0.*(t__<=0)+1440.*(t__>=1 & t__<=60/scale) + 1440.*(t__>=60/scale+1 & t__<=2*60/scale) + 1350.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 1350.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +1280.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1280.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1100.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1100.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1000.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+900.*(t__>=10*60/scale+1 & t__<=11*60/scale)+800.*(t__>=11*60/scale+1 & t__<=12*60/scale)+700.*(t__>=12*60/scale+1 & t__<=13*60/scale)+700.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +600.*(t__>=14*60/scale+1 & t__<=15*60/scale)+600.*(t__>=15*60/scale+1 & t__<=16*60/scale)+900.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1200.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1300.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +800.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1000.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 1200.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 1300.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +1440.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 1
        flow_4_enter = 800.*(t<=6*60/scale)+800.*(t>=6*60/scale+1 & t<=7*60/scale)+1000.*(t>=7*60/scale+1 & t<=8*60/scale)+1200.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1440.*(t>=9*60/scale+1 & t<=10*60/scale)+1440.*(t>=10*60/scale+1 & t<=11*60/scale)+1000.*(t>=11*60/scale+1 & t<=12*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_4_enter_ = 800.*(t_<=6*60/scale)+800.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1000.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1200.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1440.*(t_>=9*60/scale+1 & t_<=10*60/scale)+1440.*(t_>=10*60/scale+1 & t_<=11*60/scale)+1000.*(t_>=11*60/scale+1 & t_<=12*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_4_enter__ = 800.*(t__<=6*60/scale)+800.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1000.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1200.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1440.*(t__>=9*60/scale+1 & t__<=10*60/scale)+1440.*(t__>=10*60/scale+1 & t__<=11*60/scale)+1000.*(t__>=11*60/scale+1 & t__<=12*60/scale);
    case 2
        flow_4_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60/scale) + 1440.*(t>=60/scale+1 & t<=2*60/scale) + 1350.*(t>=2*60/scale+1 & t<=3*60/scale) + 1350.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +1280.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1280.*(t>=5*60/scale+1 & t<=6*60/scale)+1100.*(t>=6*60/scale+1 & t<=7*60/scale)+1100.*(t>=7*60/scale+1 & t<=8*60/scale)+1000.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+900.*(t>=10*60/scale+1 & t<=11*60/scale)+800.*(t>=11*60/scale+1 & t<=12*60/scale)+700.*(t>=12*60/scale+1 & t<=13*60/scale)+700.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +600.*(t>=14*60/scale+1 & t<=15*60/scale)+600.*(t>=15*60/scale+1 & t<=16*60/scale)+900.*(t>=16*60/scale+1 & t<=17*60/scale)+1200.*(t>=17*60/scale+1 & t<=18*60/scale)+1300.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +800.*(t>=19*60/scale+1 & t<=20*60/scale) + 1000.*(t>=20*60/scale+1 & t<=21*60/scale) + 1200.*(t>=21*60/scale+1 & t<=22*60/scale) + 1300.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +1440.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_4_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60/scale) + 1440.*(t_>=60/scale+1 & t_<=2*60/scale) + 1350.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 1350.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +1280.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1280.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1100.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1100.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1000.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+900.*(t_>=10*60/scale+1 & t_<=11*60/scale)+800.*(t_>=11*60/scale+1 & t_<=12*60/scale)+700.*(t_>=12*60/scale+1 & t_<=13*60/scale)+700.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +600.*(t_>=14*60/scale+1 & t_<=15*60/scale)+600.*(t_>=15*60/scale+1 & t_<=16*60/scale)+900.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1200.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1300.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +800.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1000.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 1200.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 1300.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +1440.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_4_enter__ = 0.*(t__<=0)+1440.*(t__>=1 & t__<=60/scale) + 1440.*(t__>=60/scale+1 & t__<=2*60/scale) + 1350.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 1350.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +1280.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1280.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1100.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1100.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1000.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+900.*(t__>=10*60/scale+1 & t__<=11*60/scale)+800.*(t__>=11*60/scale+1 & t__<=12*60/scale)+700.*(t__>=12*60/scale+1 & t__<=13*60/scale)+700.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +600.*(t__>=14*60/scale+1 & t__<=15*60/scale)+600.*(t__>=15*60/scale+1 & t__<=16*60/scale)+900.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1200.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1300.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +800.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1000.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 1200.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 1300.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +1440.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 3
        flow_4_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60/scale) + 1440.*(t>=60/scale+1 & t<=2*60/scale) + 1350.*(t>=2*60/scale+1 & t<=3*60/scale) + 1350.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +1280.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1280.*(t>=5*60/scale+1 & t<=6*60/scale)+1100.*(t>=6*60/scale+1 & t<=7*60/scale)+1100.*(t>=7*60/scale+1 & t<=8*60/scale)+1000.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+900.*(t>=10*60/scale+1 & t<=11*60/scale)+800.*(t>=11*60/scale+1 & t<=12*60/scale)+700.*(t>=12*60/scale+1 & t<=13*60/scale)+700.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +600.*(t>=14*60/scale+1 & t<=15*60/scale)+600.*(t>=15*60/scale+1 & t<=16*60/scale)+900.*(t>=16*60/scale+1 & t<=17*60/scale)+1200.*(t>=17*60/scale+1 & t<=18*60/scale)+1300.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +800.*(t>=19*60/scale+1 & t<=20*60/scale) + 1000.*(t>=20*60/scale+1 & t<=21*60/scale) + 1200.*(t>=21*60/scale+1 & t<=22*60/scale) + 1300.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +1440.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_4_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60/scale) + 1440.*(t_>=60/scale+1 & t_<=2*60/scale) + 1350.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 1350.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +1280.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1280.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1100.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1100.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1000.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+900.*(t_>=10*60/scale+1 & t_<=11*60/scale)+800.*(t_>=11*60/scale+1 & t_<=12*60/scale)+700.*(t_>=12*60/scale+1 & t_<=13*60/scale)+700.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +600.*(t_>=14*60/scale+1 & t_<=15*60/scale)+600.*(t_>=15*60/scale+1 & t_<=16*60/scale)+900.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1200.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1300.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +800.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1000.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 1200.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 1300.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +1440.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_4_enter__ = 0.*(t__<=0)+1440.*(t__>=1 & t__<=60/scale) + 1440.*(t__>=60/scale+1 & t__<=2*60/scale) + 1350.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 1350.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +1280.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1280.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1100.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1100.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1000.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+900.*(t__>=10*60/scale+1 & t__<=11*60/scale)+800.*(t__>=11*60/scale+1 & t__<=12*60/scale)+700.*(t__>=12*60/scale+1 & t__<=13*60/scale)+700.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +600.*(t__>=14*60/scale+1 & t__<=15*60/scale)+600.*(t__>=15*60/scale+1 & t__<=16*60/scale)+900.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1200.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1300.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +800.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1000.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 1200.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 1300.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +1440.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 4
        flow_4_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60/scale) + 1440.*(t>=60/scale+1 & t<=2*60/scale) + 1350.*(t>=2*60/scale+1 & t<=3*60/scale) + 1350.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +1280.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1280.*(t>=5*60/scale+1 & t<=6*60/scale)+1100.*(t>=6*60/scale+1 & t<=7*60/scale)+1100.*(t>=7*60/scale+1 & t<=8*60/scale)+1000.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+900.*(t>=10*60/scale+1 & t<=11*60/scale)+800.*(t>=11*60/scale+1 & t<=12*60/scale)+700.*(t>=12*60/scale+1 & t<=13*60/scale)+700.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +600.*(t>=14*60/scale+1 & t<=15*60/scale)+600.*(t>=15*60/scale+1 & t<=16*60/scale)+900.*(t>=16*60/scale+1 & t<=17*60/scale)+1200.*(t>=17*60/scale+1 & t<=18*60/scale)+1300.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +800.*(t>=19*60/scale+1 & t<=20*60/scale) + 1000.*(t>=20*60/scale+1 & t<=21*60/scale) + 1200.*(t>=21*60/scale+1 & t<=22*60/scale) + 1300.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +1440.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_4_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60/scale) + 1440.*(t_>=60/scale+1 & t_<=2*60/scale) + 1350.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 1350.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +1280.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1280.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1100.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1100.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1000.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+900.*(t_>=10*60/scale+1 & t_<=11*60/scale)+800.*(t_>=11*60/scale+1 & t_<=12*60/scale)+700.*(t_>=12*60/scale+1 & t_<=13*60/scale)+700.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +600.*(t_>=14*60/scale+1 & t_<=15*60/scale)+600.*(t_>=15*60/scale+1 & t_<=16*60/scale)+900.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1200.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1300.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +800.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1000.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 1200.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 1300.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +1440.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_4_enter__ = 0.*(t__<=0)+1440.*(t__>=1 & t__<=60/scale) + 1440.*(t__>=60/scale+1 & t__<=2*60/scale) + 1350.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 1350.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +1280.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1280.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1100.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1100.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1000.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+900.*(t__>=10*60/scale+1 & t__<=11*60/scale)+800.*(t__>=11*60/scale+1 & t__<=12*60/scale)+700.*(t__>=12*60/scale+1 & t__<=13*60/scale)+700.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +600.*(t__>=14*60/scale+1 & t__<=15*60/scale)+600.*(t__>=15*60/scale+1 & t__<=16*60/scale)+900.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1200.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1300.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +800.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1000.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 1200.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 1300.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +1440.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
    case 5
        flow_4_enter = 0.*(t<=0)+1440.*(t>=1 & t<=60/scale) + 1440.*(t>=60/scale+1 & t<=2*60/scale) + 1350.*(t>=2*60/scale+1 & t<=3*60/scale) + 1350.*(t>=3*60/scale+1 & t<=4*60/scale)...
    +1280.*(t>=4*60/scale+1 & t<=5*60/scale)+ 1280.*(t>=5*60/scale+1 & t<=6*60/scale)+1100.*(t>=6*60/scale+1 & t<=7*60/scale)+1100.*(t>=7*60/scale+1 & t<=8*60/scale)+1000.*(t>=8*60/scale+1 & t<=9*60/scale)...
    +1000.*(t>=9*60/scale+1 & t<=10*60/scale)+900.*(t>=10*60/scale+1 & t<=11*60/scale)+800.*(t>=11*60/scale+1 & t<=12*60/scale)+700.*(t>=12*60/scale+1 & t<=13*60/scale)+700.*(t>=13*60/scale+1 & t<=14*60/scale)...
    +600.*(t>=14*60/scale+1 & t<=15*60/scale)+600.*(t>=15*60/scale+1 & t<=16*60/scale)+900.*(t>=16*60/scale+1 & t<=17*60/scale)+1200.*(t>=17*60/scale+1 & t<=18*60/scale)+1300.*(t>=18*60/scale+1 & t<=19*60/scale)...
    +800.*(t>=19*60/scale+1 & t<=20*60/scale) + 1000.*(t>=20*60/scale+1 & t<=21*60/scale) + 1200.*(t>=21*60/scale+1 & t<=22*60/scale) + 1300.*(t>=22*60/scale+1 & t<=23*60/scale)...
    +1440.*(t>=23*60/scale+1 & t<=24*60/scale); % varying source flow: scale=5
        t_=t-1;
        flow_4_enter_ = 0.*(t_<=0)+1440.*(t_>=1 & t_<=60/scale) + 1440.*(t_>=60/scale+1 & t_<=2*60/scale) + 1350.*(t_>=2*60/scale+1 & t_<=3*60/scale) + 1350.*(t_>=3*60/scale+1 & t_<=4*60/scale)...
    +1280.*(t_>=4*60/scale+1 & t_<=5*60/scale)+ 1280.*(t_>=5*60/scale+1 & t_<=6*60/scale)+1100.*(t_>=6*60/scale+1 & t_<=7*60/scale)+1100.*(t_>=7*60/scale+1 & t_<=8*60/scale)+1000.*(t_>=8*60/scale+1 & t_<=9*60/scale)...
    +1000.*(t_>=9*60/scale+1 & t_<=10*60/scale)+900.*(t_>=10*60/scale+1 & t_<=11*60/scale)+800.*(t_>=11*60/scale+1 & t_<=12*60/scale)+700.*(t_>=12*60/scale+1 & t_<=13*60/scale)+700.*(t_>=13*60/scale+1 & t_<=14*60/scale)...
    +600.*(t_>=14*60/scale+1 & t_<=15*60/scale)+600.*(t_>=15*60/scale+1 & t_<=16*60/scale)+900.*(t_>=16*60/scale+1 & t_<=17*60/scale)+1200.*(t_>=17*60/scale+1 & t_<=18*60/scale)+1300.*(t_>=18*60/scale+1 & t_<=19*60/scale)...
    +800.*(t_>=19*60/scale+1 & t_<=20*60/scale) + 1000.*(t_>=20*60/scale+1 & t_<=21*60/scale) + 1200.*(t_>=21*60/scale+1 & t_<=22*60/scale) + 1300.*(t_>=22*60/scale+1 & t_<=23*60/scale)...
    +1440.*(t_>=23*60/scale+1 & t_<=24*60/scale); % varying source flow: scale=5
        t__=t_-1;
        flow_4_enter__ = 0.*(t__<=0)+1440.*(t__>=1 & t__<=60/scale) + 1440.*(t__>=60/scale+1 & t__<=2*60/scale) + 1350.*(t__>=2*60/scale+1 & t__<=3*60/scale) + 1350.*(t__>=3*60/scale+1 & t__<=4*60/scale)...
    +1280.*(t__>=4*60/scale+1 & t__<=5*60/scale)+ 1280.*(t__>=5*60/scale+1 & t__<=6*60/scale)+1100.*(t__>=6*60/scale+1 & t__<=7*60/scale)+1100.*(t__>=7*60/scale+1 & t__<=8*60/scale)+1000.*(t__>=8*60/scale+1 & t__<=9*60/scale)...
    +1000.*(t__>=9*60/scale+1 & t__<=10*60/scale)+900.*(t__>=10*60/scale+1 & t__<=11*60/scale)+800.*(t__>=11*60/scale+1 & t__<=12*60/scale)+700.*(t__>=12*60/scale+1 & t__<=13*60/scale)+700.*(t__>=13*60/scale+1 & t__<=14*60/scale)...
    +600.*(t__>=14*60/scale+1 & t__<=15*60/scale)+600.*(t__>=15*60/scale+1 & t__<=16*60/scale)+900.*(t__>=16*60/scale+1 & t__<=17*60/scale)+1200.*(t__>=17*60/scale+1 & t__<=18*60/scale)+1300.*(t__>=18*60/scale+1 & t__<=19*60/scale)...
    +800.*(t__>=19*60/scale+1 & t__<=20*60/scale) + 1000.*(t__>=20*60/scale+1 & t__<=21*60/scale) + 1200.*(t__>=21*60/scale+1 & t__<=22*60/scale) + 1300.*(t__>=22*60/scale+1 & t__<=23*60/scale)...
    +1440.*(t__>=23*60/scale+1 & t__<=24*60/scale); % varying source flow: scale=5
end
enter=[flow_4_enter__ flow_4_enter_ flow_4_enter];
flow_4_arriv = (cycle-gama)/cycle*enter(end-tao) + gama/cycle*enter(end-tao-1); % arriving flow at current cycle
flow_arriv(1)=flow_4_arriv*beta(1);
flow_arriv(2)=flow_4_arriv*beta(2);

flow_leave(1)=min([(green_time/cycle)*mu(1), flow_arriv(1)+q(1)/cycle*3600, beta(1)*c(1)/cycle*3600]);
flow_leave(2)=min([(green_time/cycle)*mu(2), flow_arriv(2)+q(2)/cycle*3600, beta(2)*c(2)/cycle*3600]);
q(1)=q(1)+(flow_arriv(1)-flow_leave(1))*cycle/3600;
q(2)=q(2)+(flow_arriv(2)-flow_leave(2))*cycle/3600;
flow1 = flow_leave(1);
flow2 = flow_leave(2);
n_=n+(flow_4_enter-sum(flow_leave))*cycle/3600;
%% calculate the emission
% judge the current situation: saturated, over-saturated, unsaturated scenario
if q_sum <= sum(mu)*green_time/3600 && sum(mu)*green_time/3600<= flow_4_arriv*cycle/3600+q_sum
%     N_free = max(0, n-cycle/3600*flow_4_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_4_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_4_arriv+q_sum-sum(mu)*green_time/3600; % the vehicles that cannot leave
    N_idl_2 = sum(mu)*green_time/3600-q_sum; % the vehicles that can leave
    N_idl_3 = 0;
    N_idl_4 = q_sum; % the vehicles that can leave
    N_dec = cycle/3600*flow_4_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = cycle/scale - (v_low-v_free)/dec - (v_free-v_low)/acc;
    t_idl_3 = 0;
    t_idl_4 = cycle/scale - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif sum(mu)*green_time/3600<q_sum
%     N_free = max(0, n-cycle/3600*flow_4_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_4_arriv-q_sum;
    N_idl_1 = cycle/3600*flow_4_arriv; % the vehicles that cannot leave
    N_idl_2 = 0;
    N_idl_3 = q_sum-sum(mu)*green_time/3600; % the vehicles that cannot leave
    N_idl_4 = sum(mu)*green_time/3600; % the vehicles that can leave
    N_dec = cycle/3600*flow_4_arriv;
    N_acc = sum(mu)*green_time/3600;
    N_non = 0;
    t_free = cycle;
    t_idl_1 = cycle - (v_low-v_free)/dec;
    t_idl_2 = 0;
    t_idl_3 = cycle;
    t_idl_4 = cycle/scale - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = 0;
elseif flow_4_arriv*cycle/3600+q_sum<sum(mu)*green_time/3600
    Gs = (cycle/3600*flow_4_arriv+q_sum-green_time/3600*flow_4_arriv)/(sum(mu)-flow_4_arriv)*3600;
    Gd = (green_time/3600*sum(mu)-cycle/3600*flow_4_arriv-q_sum)/(sum(mu)-flow_4_arriv)*3600;
%     N_free = max(0, n-cycle/3600*flow_4_arriv-q_sum);
    N_free = n+enter(end)*cycle/3600-cycle/3600*flow_4_arriv-q_sum;
    N_idl_1 = 0;
    N_idl_2 = Gs*sum(mu)/3600-q_sum; % the vehicles that can leave
    N_idl_3 = 0;
    N_idl_4 = q_sum; % the vehicles that can leave
    N_dec = (cycle-Gd)*flow_4_arriv/3600;
    N_acc =Gs*sum(mu)/3600;
    N_non = Gd*flow_4_arriv/3600;
    t_free = cycle;
    t_idl_1 = 0;
    t_idl_2 = cycle/scale-Gd/scale-(v_low-v_free)/dec-(v_free-v_low)/acc;
    t_idl_3 = 0;
    t_idl_4 = cycle/scale - Gd/scale - (v_free-v_low)/acc;
    t_dec = (v_low-v_free)/dec;
    t_acc = (v_free-v_low)/acc;
    t_non = Gd/scale;
else
    error('Something goes wrong with the situation judging');
end
if N_free<0
    warning('N_free is 0');
end
% calculate the emissions of all the vehicles
% [CO, HC, NOx, CO2, Fc] = VTmicro(v, a, 2);
e_free = 0.0032;

e_idl = 0.0016;

e_dec = 0.0023;

e_acc = 0.0118;

emission = (N_free*t_free+N_non*t_non).*e_free+(N_idl_1*t_idl_1+N_idl_2*t_idl_2+N_idl_3*t_idl_3+N_idl_4*t_idl_4)*e_idl...
    + N_dec*t_dec*e_dec + N_acc*t_acc*e_acc;

n=n_;
end

